/* A Bison parser, made by GNU Bison 2.7.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "gram.y"

/* This file is part of Mailfromd.
   Copyright (C) 2005, 2006, 2007, 2008, 2009, 2010, 2011 Sergey
   Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <fnmatch.h>
#include <netdb.h>
#include "mailfromd.h"
#include "prog.h"
#include "optab.h"
	
static void free_node(NODE *node); 
static void set_poll_arg(struct poll_data *poll, int kw, NODE *expr);
static int codegen(prog_counter_t *pc, NODE *node, struct exmask *exmask,
		   int finalize, size_t nautos);
static void mark(NODE *node);
static void dataseg_layout(void);
static void regex_layout(void);
static int optimize_tree(NODE *node);
static void compile_tree(NODE *node);
static NODE *reverse(NODE *in);
static size_t nodelistlength(NODE *list);
static NODE *function_call(struct function *function, size_t count,
                           NODE *subtree);
static NODE *declare_function(struct function *func, struct locus *loc,
                              size_t nautos);
static data_type_t node_type(NODE *node);
static NODE *cast_arg_list(NODE *args, size_t parmc, data_type_t *parmtype,
			   int disable_prom);
void add_xref(struct variable *var, const struct locus *locus);
static struct variable *vardecl(const char *name, data_type_t type,
                                storage_class_t sc, struct locus *loc);
static struct variable *externdecl(const char *name, struct value *value,
                                   struct locus *loc);
static int initialize_variable(struct variable *var, struct value *val,
                               const struct locus *locus);
static void apply_deferred_init(void);
static NODE *create_asgn_node(struct variable *var, NODE *expr,
                              const struct locus *loc);

NODE *defined_parm(struct variable *var, struct locus *locus);
 
static void register_auto(struct variable *var);
static void unregister_auto(struct variable *var);
static size_t forget_autos(size_t nparam, size_t prev, size_t hidden_arg);
static void optimize(NODE *node);

static NODE *root_node[smtp_state_count];
prog_counter_t entry_point[smtp_state_count];

#define PS_BEGIN 0
#define PS_END   1 

int regex_flags;        /* Should default to REG_NOSUB ? */
unsigned error_count;   /* Number of detected errors */
size_t variable_count = 0;  /* Number of variables in the data segment. */
size_t precious_count = 0;

static enum smtp_state state_tag; /* State tag of the currently processed
                                      PROG */

static struct function *func;   /* The currently compiled function */
static prog_counter_t jump_pc;  /* Pointer to the chain of jmp instructions */

/* Outermost context decides how to code exits from catches.
   Innermost context is used to access parameters. */
enum lexical_context outer_context, inner_context;

size_t catch_nesting;  /* Nesting level for catch statements */

static struct stmtlist genstmt;     /* List of generated statements */

/* State handlers and their positional parameters */ 
struct state_parms {
        int cnt;                  /* Number or positional parameters */
        data_type_t types[4];   /* Their data types */
} state_parms[] = {
        { 0,  }, /* smtp_state_none */
        { 0, }, /* smtp_state_begin */
        { 4, { dtype_string, dtype_number, dtype_number, dtype_string } },
        /* smtp_state_connect */
        { 1, { dtype_string } },  /* smtp_state_helo */
        { 2, { dtype_string, dtype_string } },  /* smtp_state_envfrom */
        { 2, { dtype_string, dtype_string } },  /* smtp_state_envrcpt */
        { 0, },  /* smtp_state_data */
        { 2, { dtype_string, dtype_string } }, /* smtp_state_header */
        { 0,  }, /* smtp_state_eoh */
        { 2, { dtype_pointer, dtype_number } }, /* smtp_state_body */
        { 0, }, /* smtp_state_eom */
        { 0, }  /* smtp_state_end */
};

struct parmtype {
        struct parmtype *next;
        data_type_t type;
};

static int
parmcount_none()
{
        return 0;
}

static data_type_t
parmtype_none(int n)
{
        return dtype_unspecified;
}

static int
parmcount_handler()
{
        return state_parms[state_tag].cnt;
}

static data_type_t
parmtype_handler(int n)
{
        return state_parms[state_tag].types[n-1];
}

static int
parmcount_catch()
{
        return 2;
}

static data_type_t
parmtype_catch(int n)
{
        switch (n) {
        case 1:
                return dtype_number;
        case 2:
                return dtype_string;
        }
        abort();
}

static int
parmcount_function()
{
        return func->parmcount;
}

static data_type_t
parmtype_function(int n)
{
        if (func->varargs && n > func->parmcount)
                return dtype_string;
        return func->parmtype[n-1];
}

struct parminfo {
        int (*parmcount)(void);
        data_type_t (*parmtype)(int n);
} parminfo[] = {
        { parmcount_none, parmtype_none },
        { parmcount_handler, parmtype_handler },
        { parmcount_catch, parmtype_catch },
        { parmcount_function, parmtype_function },
};

#define PARMCOUNT() parminfo[inner_context].parmcount()
#define PARMTYPE(n) parminfo[inner_context].parmtype(n)
#define FUNC_HIDDEN_ARGS(f) (((f)->optcount || (f)->varargs) ? 1 : 0)


data_type_t
string_to_type(const char *s)
{
        if (strcmp(s, "n") == 0)
                return dtype_number;
        else if (strcmp(s, "s") == 0)
                return dtype_string;
        else
                return dtype_unspecified;
}

const char *
type_to_string(data_type_t t)
{
        switch (t) {
        case dtype_number:
                return "number";
        case dtype_string:
                return "string";
        case dtype_unspecified:
                return "unspecified";
        case dtype_pointer:
                return "pointer";
        default:
                abort();
        }
}

static int
check_func_usage(struct function *fp, const struct locus *locus)
{
	switch (outer_context) {
	case context_handler:
		if (fp->statemask && !(STATMASK(state_tag) & fp->statemask)) {
                        parse_error_locus(locus,
                                          _("function `%s' cannot be used in "
				      "prog `%s'"),
				    fp->sym.name,
				    state_to_string(state_tag));
			return 1;
		}
		break;
		
	case context_function:
		func->statemask |= fp->statemask;
		break;

	default:
		break;
	}
	return 0;
}

static int
check_builtin_usage(const struct builtin *bp)
{
	switch (outer_context) {
	case context_handler:
		if (bp->statemask && !(STATMASK(state_tag) & bp->statemask)) {
			parse_error(_("built-in function `%s' cannot be used in "
				      "prog `%s'"),
				    bp->name,
				    state_to_string(state_tag));
			return 1;
		}
		break;
		
	case context_function:
		func->statemask |= bp->statemask;
		break;
		
	default:
		break;
	}
			
	if (bp->flags & MFD_BUILTIN_CAPTURE)
		capture_on();
	return 0;
}

static void jump_fixup(prog_counter_t pos, prog_counter_t endpos);

#define LITERAL_TEXT(lit) ((lit) ? (lit)->text : NULL)
#define LITERAL_OFF(lit) ((lit) ? (lit)->off : 0)

static int
_create_alias(void *item, void *data)
{
        struct literal *lit = item;
        struct function *fun = data;
        /* FIXME: Ideally we should pass a locus of `lit' instead of
           fun->locus. However, its only purpose is for use in redefinition
           diagnostic messages and these are never produced, because the
           grammar catches these errors earlier. This might change in
           the future.  2008-09-14 */
        install_alias(lit->text, fun, &fun->sym.locus);
        return 0;
}

#define YYLLOC_DEFAULT(Current, Rhs, N)                         \
        do {                                                    \
                if (N) {                                        \
                        (Current).beg = YYRHSLOC(Rhs, 1).beg;   \
                        (Current).end = YYRHSLOC(Rhs, N).end;   \
                } else {                                        \
                        (Current).beg = YYRHSLOC(Rhs, 0).end;   \
                        (Current).end = (Current).beg;          \
                }                                               \
        } while (0)

#define YY_LOCATION_PRINT(File, Loc) do {                       \
        if (LOCUS_EQ(&(Loc).beg, &(Loc).end))                   \
                fprintf(File, "%s:%lu.%lu-%lu.%lu",             \
                        (Loc).beg.file,                         \
                        (Loc).beg.line, (Loc).beg.point,        \
                        (Loc).end.line, (Loc).end.point);       \
        else                                                    \
                fprintf(File, "%s:%lu.%lu-%s:%lu.%lu",          \
                        (Loc).beg.file,                         \
                        (Loc).beg.line, (Loc).beg.point,        \
                        (Loc).end.file,                         \
                        (Loc).end.line, (Loc).end.point);       \
        } while (0)


/* Line 371 of yacc.c  */
#line 379 "gram.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_ACCEPT = 258,
     T_REJECT = 259,
     T_TEMPFAIL = 260,
     T_CONTINUE = 261,
     T_DISCARD = 262,
     T_ADD = 263,
     T_REPLACE = 264,
     T_DELETE = 265,
     T_PROG = 266,
     T_BEGIN = 267,
     T_END = 268,
     T_IF = 269,
     T_FI = 270,
     T_ELSE = 271,
     T_ELIF = 272,
     T_ON = 273,
     T_HOST = 274,
     T_FROM = 275,
     T_AS = 276,
     T_DO = 277,
     T_DONE = 278,
     T_POLL = 279,
     T_MATCHES = 280,
     T_FNMATCHES = 281,
     T_MXMATCHES = 282,
     T_MXFNMATCHES = 283,
     T_WHEN = 284,
     T_PASS = 285,
     T_SET = 286,
     T_CATCH = 287,
     T_TRY = 288,
     T_THROW = 289,
     T_ECHO = 290,
     T_RETURNS = 291,
     T_RETURN = 292,
     T_FUNC = 293,
     T_SWITCH = 294,
     T_CASE = 295,
     T_DEFAULT = 296,
     T_CONST = 297,
     T_FOR = 298,
     T_LOOP = 299,
     T_WHILE = 300,
     T_BREAK = 301,
     T_NEXT = 302,
     T_ARGCOUNT = 303,
     T_ALIAS = 304,
     T_DOTS = 305,
     T_ARGX = 306,
     T_VAPTR = 307,
     T_PRECIOUS = 308,
     T_OR = 309,
     T_AND = 310,
     T_EQ = 311,
     T_NE = 312,
     T_LT = 313,
     T_LE = 314,
     T_GT = 315,
     T_GE = 316,
     T_NOT = 317,
     T_LOGAND = 318,
     T_LOGOR = 319,
     T_LOGXOR = 320,
     T_LOGNOT = 321,
     T_REQUIRE = 322,
     T_IMPORT = 323,
     T_STATIC = 324,
     T_PUBLIC = 325,
     T_MODULE = 326,
     T_BYE = 327,
     T_DCLEX = 328,
     T_SHL = 329,
     T_SHR = 330,
     T_COMPOSE = 331,
     T_MODBEG = 332,
     T_MODEND = 333,
     T_STRING = 334,
     T_SYMBOL = 335,
     T_IDENTIFIER = 336,
     T_ARG = 337,
     T_NUMBER = 338,
     T_BACKREF = 339,
     T_BUILTIN = 340,
     T_FUNCTION = 341,
     T_TYPE = 342,
     T_TYPECAST = 343,
     T_VARIABLE = 344,
     T_BOGUS = 345,
     T_UMINUS = 346
   };
#endif
/* Tokens.  */
#define T_ACCEPT 258
#define T_REJECT 259
#define T_TEMPFAIL 260
#define T_CONTINUE 261
#define T_DISCARD 262
#define T_ADD 263
#define T_REPLACE 264
#define T_DELETE 265
#define T_PROG 266
#define T_BEGIN 267
#define T_END 268
#define T_IF 269
#define T_FI 270
#define T_ELSE 271
#define T_ELIF 272
#define T_ON 273
#define T_HOST 274
#define T_FROM 275
#define T_AS 276
#define T_DO 277
#define T_DONE 278
#define T_POLL 279
#define T_MATCHES 280
#define T_FNMATCHES 281
#define T_MXMATCHES 282
#define T_MXFNMATCHES 283
#define T_WHEN 284
#define T_PASS 285
#define T_SET 286
#define T_CATCH 287
#define T_TRY 288
#define T_THROW 289
#define T_ECHO 290
#define T_RETURNS 291
#define T_RETURN 292
#define T_FUNC 293
#define T_SWITCH 294
#define T_CASE 295
#define T_DEFAULT 296
#define T_CONST 297
#define T_FOR 298
#define T_LOOP 299
#define T_WHILE 300
#define T_BREAK 301
#define T_NEXT 302
#define T_ARGCOUNT 303
#define T_ALIAS 304
#define T_DOTS 305
#define T_ARGX 306
#define T_VAPTR 307
#define T_PRECIOUS 308
#define T_OR 309
#define T_AND 310
#define T_EQ 311
#define T_NE 312
#define T_LT 313
#define T_LE 314
#define T_GT 315
#define T_GE 316
#define T_NOT 317
#define T_LOGAND 318
#define T_LOGOR 319
#define T_LOGXOR 320
#define T_LOGNOT 321
#define T_REQUIRE 322
#define T_IMPORT 323
#define T_STATIC 324
#define T_PUBLIC 325
#define T_MODULE 326
#define T_BYE 327
#define T_DCLEX 328
#define T_SHL 329
#define T_SHR 330
#define T_COMPOSE 331
#define T_MODBEG 332
#define T_MODEND 333
#define T_STRING 334
#define T_SYMBOL 335
#define T_IDENTIFIER 336
#define T_ARG 337
#define T_NUMBER 338
#define T_BACKREF 339
#define T_BUILTIN 340
#define T_FUNCTION 341
#define T_TYPE 342
#define T_TYPECAST 343
#define T_VARIABLE 344
#define T_BOGUS 345
#define T_UMINUS 346



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 316 "gram.y"

	struct literal *literal;
	struct stmtlist stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_data poll;
	struct pollarg {
		int kw;
		NODE *expr;
	} pollarg;
	struct arglist {
		NODE *head;
		NODE *tail;
		size_t count;
	} arglist;
	long number;
	const struct builtin *builtin;
	struct variable *var;
	enum smtp_state state;
	struct {
		int qualifier;
	} matchtype;
	data_type_t type;
	struct parmtype *parm;
	struct parmlist {
		struct parmtype *head, *tail;
		size_t count;
		size_t optcount;
		int varargs;
	} parmlist;
	enum lexical_context tie_in;
	struct function *function;
	struct {
		struct valist *head, *tail;
	} valist_list;
	struct {
		int all;
		struct valist *valist;
	} catchlist;
	struct valist *valist;
	struct value value;
	struct {
		struct case_stmt *head, *tail;
	} case_list ;
	struct case_stmt *case_stmt;
	struct loop_node loop;
	struct {
		int code;
	} progspecial;
	mu_list_t list;
	struct import_rule_list import_rule_list;
	char *string;


/* Line 387 of yacc.c  */
#line 659 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif

extern YYSTYPE yylval;
extern YYLTYPE yylloc;
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 700 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  32
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1569

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  104
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  89
/* YYNRULES -- Number of rules.  */
#define YYNRULES  224
/* YYNRULES -- Number of states.  */
#define YYNSTATES  384

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   346

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    96,     2,     2,
      99,   100,    94,    92,    98,    93,    91,    95,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   102,   101,
       2,     2,     2,     2,   103,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    97
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    11,    13,    15,    18,    21,
      23,    30,    31,    33,    37,    42,    45,    51,    52,    54,
      56,    60,    62,    64,    70,    75,    82,    84,    86,    88,
      90,    92,    94,    96,   100,   105,   109,   110,   113,   115,
     117,   119,   124,   127,   134,   135,   137,   139,   141,   145,
     146,   148,   150,   154,   156,   160,   163,   165,   166,   168,
     170,   173,   176,   177,   180,   182,   184,   187,   189,   191,
     193,   195,   197,   199,   201,   203,   205,   207,   209,   213,
     216,   220,   222,   224,   226,   229,   232,   235,   244,   247,
     256,   258,   260,   262,   264,   268,   272,   275,   276,   278,
     280,   283,   287,   290,   292,   298,   300,   302,   304,   310,
     311,   316,   319,   325,   327,   330,   335,   339,   341,   345,
     347,   349,   351,   353,   355,   357,   359,   367,   369,   370,
     372,   373,   375,   377,   381,   383,   386,   389,   390,   393,
     396,   399,   402,   406,   410,   414,   418,   422,   426,   430,
     434,   438,   442,   444,   445,   447,   449,   453,   457,   461,
     465,   469,   473,   477,   481,   485,   489,   493,   495,   499,
     504,   506,   509,   512,   515,   517,   519,   521,   523,   525,
     528,   531,   533,   535,   538,   540,   542,   544,   546,   551,
     553,   557,   562,   566,   571,   575,   577,   581,   583,   585,
     587,   590,   595,   596,   603,   605,   607,   611,   613,   616,
     622,   628,   630,   632,   635,   639,   642,   644,   647,   650,
     653,   656,   659,   661,   664
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     105,     0,    -1,   106,    -1,   107,    -1,   110,   107,   112,
      -1,   115,    -1,   108,    -1,   107,   115,    -1,   107,   108,
      -1,   111,    -1,   111,    77,   109,   107,   112,    78,    -1,
      -1,   110,    -1,    71,   114,    91,    -1,    71,   114,   120,
      91,    -1,    67,   114,    -1,    20,   114,    68,   113,    91,
      -1,    -1,    72,    -1,   114,    -1,   113,    98,   114,    -1,
      79,    -1,    81,    -1,    11,   134,    22,   135,    23,    -1,
     116,    22,   135,    23,    -1,   119,    38,   123,    22,   135,
      23,    -1,   118,    -1,   121,    -1,   122,    -1,    12,    -1,
      13,    -1,    81,    -1,    89,    -1,   119,    87,   117,    -1,
     119,    87,   117,   166,    -1,    31,   117,   166,    -1,    -1,
     119,   120,    -1,    53,    -1,    69,    -1,    70,    -1,   119,
      42,   117,   166,    -1,    73,    81,    -1,   117,    99,   124,
     100,   130,   133,    -1,    -1,   125,    -1,   128,    -1,    50,
      -1,   126,   101,   128,    -1,    -1,   127,    -1,   129,    -1,
     127,    98,   129,    -1,   127,    -1,   127,    98,    50,    -1,
      87,   117,    -1,    87,    -1,    -1,   131,    -1,   132,    -1,
     131,   132,    -1,    49,   117,    -1,    -1,    36,    87,    -1,
      81,    -1,   136,    -1,   135,   136,    -1,   147,    -1,   139,
      -1,   137,    -1,   138,    -1,   178,    -1,   183,    -1,   184,
      -1,   175,    -1,   121,    -1,   158,    -1,   165,    -1,    31,
     117,   166,    -1,    87,   117,    -1,    87,   117,   166,    -1,
     140,    -1,   142,    -1,    30,    -1,    35,   166,    -1,     3,
     143,    -1,     4,   143,    -1,     4,    99,   167,    98,   141,
      98,   167,   100,    -1,     5,   143,    -1,     5,    99,   167,
      98,   141,    98,   167,   100,    -1,     6,    -1,     7,    -1,
     167,    -1,   146,    -1,     8,   155,   166,    -1,     9,   155,
     166,    -1,    10,   155,    -1,    -1,   144,    -1,   145,    -1,
     145,   146,    -1,   145,   146,   166,    -1,   145,   166,    -1,
      83,    -1,    83,    91,    83,    91,    83,    -1,   148,    -1,
     150,    -1,   185,    -1,    14,   166,   135,   149,    15,    -1,
      -1,    17,   166,   135,   149,    -1,    16,   135,    -1,    39,
     166,    22,   151,    23,    -1,   152,    -1,   151,   152,    -1,
      40,   153,   102,   135,    -1,    41,   102,   135,    -1,   154,
      -1,   153,    54,   154,    -1,    79,    -1,    83,    -1,   154,
      -1,    25,    -1,    27,    -1,    26,    -1,    28,    -1,    44,
     159,   161,    22,   135,    23,   164,    -1,   160,    -1,    -1,
     117,    -1,    -1,   162,    -1,   163,    -1,   162,    98,   163,
      -1,   135,    -1,    43,   135,    -1,    45,   166,    -1,    -1,
      45,   166,    -1,    46,   160,    -1,    47,   160,    -1,    62,
     166,    -1,   166,    56,   166,    -1,   166,    57,   166,    -1,
     166,    58,   166,    -1,   166,    59,   166,    -1,   166,    60,
     166,    -1,   166,    61,   166,    -1,   166,   156,   166,    -1,
     166,   157,   166,    -1,   166,    54,   166,    -1,   166,    55,
     166,    -1,   168,    -1,    -1,   166,    -1,   169,    -1,   168,
      92,   168,    -1,   168,    91,   168,    -1,   168,    93,   168,
      -1,   168,    94,   168,    -1,   168,    95,   168,    -1,   168,
      96,   168,    -1,   168,    63,   168,    -1,   168,    64,   168,
      -1,   168,    65,   168,    -1,   168,    74,   168,    -1,   168,
      75,   168,    -1,   175,    -1,    99,   166,   100,    -1,    88,
      99,   166,   100,    -1,   170,    -1,    93,   168,    -1,    92,
     168,    -1,    66,   168,    -1,    80,    -1,    83,    -1,    84,
      -1,   173,    -1,    48,    -1,   103,    89,    -1,    52,   174,
      -1,   171,    -1,   172,    -1,   171,   172,    -1,    79,    -1,
      76,    -1,   177,    -1,    82,    -1,    51,    99,   166,   100,
      -1,   173,    -1,    99,   173,   100,    -1,    85,    99,   176,
     100,    -1,    85,    99,   100,    -1,    86,    99,   176,   100,
      -1,    86,    99,   100,    -1,   166,    -1,   176,    98,   166,
      -1,    89,    -1,    90,    -1,   180,    -1,   179,   180,    -1,
      33,    22,   135,    23,    -1,    -1,    32,   182,    22,   181,
     135,    23,    -1,    94,    -1,   153,    -1,    34,   154,   166,
      -1,    37,    -1,    37,   166,    -1,   186,   188,   187,   191,
      23,    -1,   186,   175,   187,   191,    23,    -1,    18,    -1,
      22,    -1,    24,   166,    -1,    24,   166,   189,    -1,    24,
     189,    -1,   190,    -1,   189,   190,    -1,    43,   166,    -1,
      19,   166,    -1,    21,   166,    -1,    20,   166,    -1,   192,
      -1,   191,   192,    -1,    29,   153,   102,   135,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   499,   499,   524,   525,   531,   535,   536,   547,   560,
     564,   572,   575,   578,   586,   601,   605,   611,   612,   618,
     623,   631,   632,   635,   646,   672,   690,   694,   698,   704,
     710,   718,   719,   725,   739,   776,   804,   807,   816,   820,
     824,   831,   878,   884,   915,   919,   922,   923,   928,   943,
     948,   951,   958,   967,   968,   975,   984,   995,   998,  1001,
    1006,  1013,  1020,  1023,  1029,  1041,  1047,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1075,  1076,  1077,  1080,  1104,
    1110,  1122,  1135,  1143,  1147,  1155,  1163,  1169,  1177,  1183,
    1191,  1197,  1205,  1206,  1215,  1222,  1229,  1239,  1242,  1245,
    1252,  1260,  1268,  1277,  1290,  1313,  1314,  1315,  1318,  1328,
    1331,  1338,  1344,  1388,  1392,  1399,  1407,  1417,  1423,  1434,
    1439,  1446,  1459,  1463,  1469,  1473,  1482,  1493,  1500,  1503,
    1507,  1510,  1513,  1533,  1563,  1568,  1573,  1581,  1584,  1590,
    1604,  1629,  1635,  1642,  1649,  1656,  1663,  1670,  1677,  1691,
    1699,  1706,  1713,  1717,  1720,  1723,  1724,  1731,  1737,  1744,
    1751,  1758,  1765,  1772,  1779,  1786,  1793,  1802,  1807,  1811,
    1815,  1816,  1822,  1826,  1834,  1838,  1843,  1847,  1848,  1852,
    1858,  1863,  1866,  1867,  1875,  1880,  1883,  1887,  1891,  1918,
    1919,  1925,  1950,  1965,  1973,  1983,  1989,  1998,  2002,  2008,
    2016,  2024,  2032,  2031,  2062,  2066,  2073,  2089,  2101,  2124,
    2183,  2191,  2197,  2203,  2212,  2221,  2227,  2232,  2239,  2244,
    2249,  2254,  2262,  2266,  2274
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "\"accept\"", "\"reject\"",
  "\"tempfail\"", "\"continue\"", "\"discard\"", "\"add\"", "\"replace\"",
  "\"delete\"", "\"prog\"", "\"begin\"", "\"end\"", "\"if\"", "\"fi\"",
  "\"else\"", "\"elif\"", "\"on\"", "\"host\"", "\"from\"", "\"as\"",
  "\"do\"", "\"done\"", "\"poll\"", "\"matches\"", "\"fnmatches\"",
  "\"mx matches\"", "\"mx fnmatches\"", "\"when\"", "\"pass\"", "\"set\"",
  "\"catch\"", "\"try\"", "\"throw\"", "\"echo\"", "\"returns\"",
  "\"return\"", "\"func\"", "\"switch\"", "\"case\"", "\"default\"",
  "\"const\"", "\"for\"", "\"loop\"", "\"while\"", "\"break\"", "\"next\"",
  "\"$#\"", "\"alias\"", "\"...\"", "\"$(n)\"", "\"vaptr\"",
  "\"precious\"", "\"or\"", "\"and\"", "\"==\"", "\"!=\"", "\"<\"",
  "\"<=\"", "\">\"", "\">=\"", "\"!\"", "\"&\"", "\"|\"", "\"^\"", "\"~\"",
  "\"require\"", "\"import\"", "\"static\"", "\"public\"", "\"module\"",
  "\"bye\"", "\"dclex\"", "\"<<\"", "\">>\"", "\"composed string\"",
  "T_MODBEG", "T_MODEND", "\"string\"", "\"MTA macro\"", "\"identifier\"",
  "\"$n\"", "\"number\"", "\"back reference\"", "\"builtin function\"",
  "\"function\"", "\"data type\"", "\"typecast\"", "\"variable\"",
  "T_BOGUS", "'.'", "'+'", "'-'", "'*'", "'/'", "'%'", "T_UMINUS", "','",
  "'('", "')'", "';'", "':'", "'@'", "$accept", "input", "program",
  "decllist", "modcntl", "opt_moddecl", "moddecl", "require", "bye",
  "imports", "literal", "decl", "progspecial", "varname", "vardecl",
  "qualifiers", "qualifier", "constdecl", "exdecl", "fundecl", "parmdecl",
  "params", "opt_parmlist", "parmlist", "fparmlist", "parm", "aliasdecl",
  "aliases", "alias", "retdecl", "state_ident", "stmtlist", "stmt", "asgn",
  "autodcl", "action", "sendmail_action", "maybe_xcode_expr",
  "header_action", "maybe_triplet", "triplet", "code", "xcode",
  "condition", "if_cond", "else_cond", "case_cond", "cond_branches",
  "cond_branch", "valist", "value", "string", "matches", "fnmatches",
  "loopstmt", "loop_ident", "opt_ident", "opt_loop_parms",
  "loop_parm_list", "loop_parm", "opt_while", "jumpstmt", "expr",
  "maybe_expr", "simp_expr", "atom_expr", "atom", "strcat", "strval",
  "argref", "paren_argref", "funcall", "arglist", "variable", "catch",
  "try_block", "simple_catch", "@1", "catchlist", "throw", "return",
  "on_cond", "on", "do", "pollstmt", "pollarglist", "pollarg", "branches",
  "branch", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    46,    43,    45,    42,    47,    37,   346,    44,    40,
      41,    59,    58,    64
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   104,   105,   106,   106,   107,   107,   107,   107,   108,
     108,   109,   109,   110,   110,   111,   111,   112,   112,   113,
     113,   114,   114,   115,   115,   115,   115,   115,   115,   116,
     116,   117,   117,   118,   118,   118,   119,   119,   120,   120,
     120,   121,   122,   123,   124,   124,   125,   125,   125,   126,
     126,   127,   127,   128,   128,   129,   129,   130,   130,   131,
     131,   132,   133,   133,   134,   135,   135,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   137,   138,
     138,   139,   139,   139,   139,   140,   140,   140,   140,   140,
     140,   140,   141,   141,   142,   142,   142,   143,   143,   144,
     144,   144,   144,   145,   146,   147,   147,   147,   148,   149,
     149,   149,   150,   151,   151,   152,   152,   153,   153,   154,
     154,   155,   156,   156,   157,   157,   158,   159,   160,   160,
     161,   161,   162,   162,   163,   163,   163,   164,   164,   165,
     165,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   167,   167,   168,   168,   168,   168,   168,
     168,   168,   168,   168,   168,   168,   168,   169,   169,   169,
     169,   169,   169,   169,   170,   170,   170,   170,   170,   170,
     170,   170,   171,   171,   172,   172,   173,   173,   173,   174,
     174,   175,   175,   175,   175,   176,   176,   177,   177,   178,
     178,   179,   181,   180,   182,   182,   183,   184,   184,   185,
     185,   186,   187,   188,   188,   188,   189,   189,   190,   190,
     190,   190,   191,   191,   192
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     3,     1,     1,     2,     2,     1,
       6,     0,     1,     3,     4,     2,     5,     0,     1,     1,
       3,     1,     1,     5,     4,     6,     1,     1,     1,     1,
       1,     1,     1,     3,     4,     3,     0,     2,     1,     1,
       1,     4,     2,     6,     0,     1,     1,     1,     3,     0,
       1,     1,     3,     1,     3,     2,     1,     0,     1,     1,
       2,     2,     0,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     2,
       3,     1,     1,     1,     2,     2,     2,     8,     2,     8,
       1,     1,     1,     1,     3,     3,     2,     0,     1,     1,
       2,     3,     2,     1,     5,     1,     1,     1,     5,     0,
       4,     2,     5,     1,     2,     4,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     7,     1,     0,     1,
       0,     1,     1,     3,     1,     2,     2,     0,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     0,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     3,     4,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     2,
       2,     1,     1,     2,     1,     1,     1,     1,     4,     1,
       3,     4,     3,     4,     3,     1,     3,     1,     1,     1,
       2,     4,     0,     6,     1,     1,     3,     1,     2,     5,
       5,     1,     1,     2,     3,     2,     1,     2,     2,     2,
       2,     2,     1,     2,     4
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      36,     0,    29,    30,     0,     0,     0,     0,     0,     0,
       2,    36,     6,    36,     9,     5,     0,    26,     0,    27,
      28,    64,     0,    21,    22,     0,    31,    32,     0,    15,
       0,    42,     1,     8,     7,    36,    11,    36,     0,     0,
      38,    39,    40,     0,    37,    36,     0,   178,     0,     0,
       0,     0,   185,   184,   174,   187,   175,   176,     0,     0,
       0,   197,   198,     0,     0,     0,     0,    35,   152,   155,
     170,   181,   182,   177,   167,   186,    13,     0,    18,     4,
      36,    12,    97,    97,    97,    90,    91,     0,     0,     0,
       0,   211,    83,     0,     0,     0,     0,     0,   207,     0,
     128,   128,   128,     0,     0,    75,    36,    65,    69,    70,
      68,    81,    82,    67,   105,   106,    76,    77,    74,    71,
       0,   199,    72,    73,   107,     0,     0,     0,     0,    33,
      36,     0,    19,     0,     0,   189,   180,   141,   173,     0,
       0,     0,   172,   171,     0,   179,   122,   124,   123,   125,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   183,    14,    36,   103,    85,    98,    99,   153,    86,
     153,    88,   119,   120,   121,     0,     0,    96,    36,     0,
     204,   205,   117,     0,    36,     0,    84,   208,     0,   129,
      36,   127,   139,   140,    79,    24,    66,   200,     0,     0,
       0,    44,    36,    41,    34,    23,    16,     0,     0,     0,
     192,   195,     0,   194,     0,     0,   168,   150,   151,   142,
     143,   144,   145,   146,   147,   148,   149,   162,   163,   164,
     165,   166,   157,   156,   158,   159,   160,   161,     0,   175,
     100,   102,   154,     0,     0,    94,    95,    36,    78,     0,
     202,    36,   206,     0,    36,     0,    36,     0,   131,   132,
      80,     0,     0,     0,     0,   213,   215,   216,   212,     0,
       0,    47,    56,     0,    45,     0,    50,    46,    51,    36,
      20,   188,   190,     0,   191,   193,   169,    10,     0,   101,
     153,   153,    36,     0,     0,   118,    36,   201,     0,     0,
       0,   113,    36,   136,    36,    36,   219,   221,   220,   218,
     214,   217,     0,     0,   222,     0,    55,    57,     0,     0,
      25,   196,     0,     0,    93,    92,     0,    36,    36,   108,
      36,     0,    36,   112,   114,    36,   133,     0,   210,   223,
     209,     0,    62,    58,    59,    53,    48,    54,    52,     0,
     153,   153,    36,   203,    36,    36,   137,    36,    61,     0,
      43,    60,   104,     0,     0,   110,    36,     0,   126,    36,
      63,    87,    89,   138
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     9,    10,    11,    12,    80,    13,    14,    79,   131,
      25,    15,    16,   199,    17,   104,    44,   105,    20,   127,
     283,   284,   285,   286,   287,   288,   352,   353,   354,   370,
      22,   266,   107,   108,   109,   110,   111,   333,   112,   175,
     176,   177,   334,   113,   114,   304,   115,   310,   311,   191,
     184,   185,   158,   159,   116,   200,   201,   267,   268,   269,
     378,   117,   252,   335,    68,    69,    70,    71,    72,    73,
     136,    74,   222,    75,   119,   120,   121,   306,   193,   122,
     123,   124,   125,   279,   210,   276,   277,   323,   324
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -265
static const yytype_int16 yypact[] =
{
     203,   -79,  -265,  -265,     7,   -17,     7,     7,   -60,    26,
    -265,   189,  -265,   227,    13,  -265,    22,  -265,    66,  -265,
    -265,  -265,    85,  -265,  -265,    30,  -265,  -265,  1337,  -265,
     159,  -265,  -265,  -265,  -265,    83,    39,  1169,   -17,   -17,
    -265,  -265,  -265,   -17,  -265,  1169,     7,  -265,    16,   137,
    1337,   397,  -265,  -265,  -265,  -265,  -265,  -265,    63,    70,
      91,  -265,  -265,   397,   397,  1337,    48,  1166,  1437,  -265,
    -265,   -21,  -265,  -265,  -265,  -265,  -265,   119,  -265,  -265,
     227,  -265,   130,   -69,   -59,  -265,  -265,   -52,   -52,   -52,
    1337,  -265,  -265,   -17,    23,   196,   -52,  1337,  1337,  1337,
     -17,   -17,   -17,   -17,   226,  -265,   854,  -265,  -265,  -265,
    -265,  -265,  -265,  -265,  -265,  -265,  -265,  -265,  -265,  -265,
     192,  -265,  -265,  -265,  -265,    -1,   133,   211,  1337,  1337,
     899,   -66,  -265,  1337,   115,  -265,  -265,  1211,  -265,  1251,
    1294,  1337,  -265,  -265,    20,  -265,  -265,  -265,  -265,  -265,
    1337,  1337,  1337,  1337,  1337,  1337,  1337,  1337,  1337,  1337,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,  -265,  -265,  1222,  -265,  -265,  -265,  1380,  1337,  -265,
    1337,  -265,  -265,  -265,  -265,  1337,  1337,  -265,   499,  1337,
    -265,   188,  -265,   219,  1169,  1337,  1166,  1166,   655,  -265,
     558,  -265,  -265,  -265,  1337,  -265,  -265,  -265,  1198,   231,
     231,   -33,  1169,  1166,  1166,  -265,  -265,     7,   262,   154,
    -265,  1166,    -7,  -265,    84,   597,  -265,   348,  1211,  1449,
    1449,   223,   223,   223,   223,  1449,  1449,  1230,  1473,   100,
     358,   358,  1460,   216,   216,  -265,  -265,  -265,   185,   175,
    1337,  1166,  1166,   169,   173,  1166,  1166,   603,  1166,   -52,
    -265,   944,  1166,    19,  1169,  1337,   380,   250,   193,  -265,
    1166,  1337,  1337,  1337,  1337,  1461,   187,  -265,  -265,   257,
     257,  -265,   -17,   198,  -265,   200,   151,  -265,  -265,   989,
    -265,  -265,  -265,  1337,  -265,  -265,  -265,  -265,   221,  1166,
    1380,  1380,  1169,  1337,   284,  -265,  1169,  -265,   -52,   205,
     111,  -265,   425,  1166,  1169,   764,  1166,  1166,  1166,  1166,
     187,  -265,   -52,   131,  -265,   141,  -265,   253,   237,   -30,
    -265,  1166,   217,   228,  -265,  -265,   229,  1034,   499,  -265,
    1079,   -41,  1169,  -265,  -265,  1124,  -265,   -36,  -265,  -265,
    -265,   -17,   278,   253,  -265,   232,  -265,  -265,  -265,   242,
    1337,  1337,   603,  -265,  1169,   661,   287,  1169,  -265,   247,
    -265,  -265,  -265,   239,   241,  -265,   719,  1337,  -265,   809,
    -265,  -265,  -265,  1166
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -265,  -265,  -265,     2,    -2,  -265,   301,  -265,   171,  -265,
       4,     8,  -265,    -4,  -265,    38,   312,    52,  -265,  -265,
    -265,  -265,  -265,    17,    18,    21,  -265,  -265,     1,  -265,
    -265,   -29,     3,  -265,  -265,  -265,  -265,    50,  -265,    89,
    -265,  -265,   180,  -265,  -265,   -10,  -265,  -265,    49,  -255,
     -91,   110,  -265,  -265,  -265,  -265,    76,  -265,  -265,    45,
    -265,  -265,   -28,  -174,   -22,  -265,  -265,  -265,   290,   -42,
    -265,    -9,   224,  -265,  -265,  -265,   243,  -265,  -265,  -265,
    -265,  -265,  -265,   156,  -265,    94,  -264,    92,   -64
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -225
static const yytype_int16 yytable[] =
{
      67,    28,    21,   192,   253,   195,   254,   135,   106,    33,
      29,    30,   321,   259,   174,    35,   130,   281,   259,    34,
     357,    31,   137,   208,   174,   216,    32,   182,   118,   138,
     178,   183,   217,    33,   126,   128,   118,   144,    18,   129,
     180,   142,   143,    34,    37,   146,   147,   148,   149,    18,
     132,    18,    19,   341,   282,    52,   321,   282,    53,   308,
     309,   364,   188,    19,    26,    19,   367,   347,   -49,   196,
     197,   198,    27,    18,   150,   151,   152,   153,   154,   155,
     156,   157,   173,   -17,    58,    59,    23,    19,    24,   189,
      36,   293,   219,   294,     1,     2,     3,   118,    46,   204,
     213,   214,   182,     4,    38,   218,   183,    45,    39,   206,
       7,   221,   221,   225,     5,   133,   209,   190,    18,    40,
     226,   118,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    19,   206,   343,    41,    42,   145,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   251,
       6,   308,   309,    43,   348,    78,     8,   255,   256,   257,
     322,   258,   139,   160,   350,   261,    48,   262,   305,   140,
     322,    33,   179,   181,   163,   164,   270,   202,   203,   118,
     275,    34,   293,   289,   295,   118,   373,   374,    48,    -3,
     141,   118,   166,   167,   168,   169,   170,    55,   186,   187,
       1,     2,     3,   118,    61,    62,   271,   272,   273,     4,
     172,    18,    40,   174,     1,     2,     3,   192,   194,    55,
       5,   290,   299,     4,    94,    19,    61,    62,    41,    42,
     274,   192,   211,   212,     5,   312,   134,   313,     1,     2,
       3,   260,   259,   316,   317,   318,   319,     4,   118,   329,
      76,   -53,   118,   278,   292,   118,     6,   118,     5,   349,
     206,   349,     8,   297,   206,   331,   298,   300,    39,   206,
       6,   301,   314,   337,     7,   338,     8,   340,   326,    40,
     118,  -225,  -225,  -225,  -225,   345,   322,   146,   147,   148,
     149,   315,   206,   118,     6,    41,    42,   118,   327,   339,
       8,   328,   351,   118,   332,   118,   118,   342,   359,   362,
     168,   169,   170,   365,   369,   206,   150,   151,   152,   153,
     154,   155,   156,   157,   282,   372,   360,   361,   118,   118,
     329,   118,   377,   118,   380,   376,   118,    81,   379,   381,
     206,   382,    77,   206,   248,   355,   356,   368,   206,   383,
     358,   336,   375,   118,   371,   118,   118,   250,   118,   344,
     346,   171,   291,   207,   224,   206,   280,   118,   206,   320,
     118,     0,   325,   146,   147,   148,   149,     0,     0,   206,
       0,     0,   206,    82,    83,    84,    85,    86,    87,    88,
      89,     0,     0,     0,    90,     0,     0,     0,    91,     0,
       0,     0,  -134,   151,   152,   153,   154,   155,   156,   157,
      92,    93,    94,    95,    96,    97,     0,    98,     0,    99,
       0,     0,     0,     0,   100,     0,   101,   102,    82,    83,
      84,    85,    86,    87,    88,    89,     0,     0,     0,    90,
       0,     0,     0,    91,     0,    47,     0,  -135,    48,    49,
     166,   167,   168,   169,   170,    92,    93,    94,    95,    96,
      97,     0,    98,    51,    99,    58,    59,   103,     0,   100,
       0,   101,   102,    52,     0,     0,    53,    54,  -134,    55,
      56,    57,    58,    59,     0,    60,    61,    62,     0,    63,
      64,     0,     0,     0,     0,     0,    65,     0,     0,     0,
      66,     0,    82,    83,    84,    85,    86,    87,    88,    89,
      58,    59,   103,    90,     0,     0,     0,    91,     0,     0,
       0,     0,     0,  -135,   146,   147,   148,   149,     0,    92,
      93,    94,    95,    96,    97,     0,    98,     0,    99,     0,
       0,     0,     0,   100,     0,   101,   102,     0,     0,     0,
       0,     0,     0,   150,   151,   152,   153,   154,   155,   156,
     157,    82,    83,    84,    85,    86,    87,    88,    89,     0,
       0,     0,    90,     0,     0,     0,    91,     0,     0,     0,
    -130,     0,     0,     0,    58,    59,   103,     0,    92,    93,
      94,    95,    96,    97,     0,    98,     0,    99,     0,     0,
       0,   264,   100,   265,   101,   102,    82,    83,    84,    85,
      86,    87,    88,    89,     0,     0,     0,    90,  -109,   302,
     303,    91,   146,   147,   148,   149,     0,     0,     0,     0,
       0,     0,     0,    92,    93,    94,    95,    96,    97,     0,
      98,     0,    99,    58,    59,   103,     0,   100,     0,   101,
     102,   150,   151,   152,   153,   154,   155,   156,   157,     0,
       0,     0,     0,     0,    82,    83,    84,    85,    86,    87,
      88,    89,     0,     0,     0,    90,     0,   263,     0,    91,
     146,   147,   148,   149,  -116,     0,     0,     0,    58,    59,
     103,    92,    93,    94,    95,    96,    97,   296,    98,     0,
      99,  -116,  -116,     0,     0,   100,     0,   101,   102,   150,
     151,   152,   153,   154,   155,   156,   157,     0,     0,     0,
       0,     0,    82,    83,    84,    85,    86,    87,    88,    89,
       0,     0,     0,    90,     0,     0,     0,    91,     0,     0,
       0,     0,  -115,     0,     0,     0,    58,    59,   103,    92,
      93,    94,    95,    96,    97,     0,    98,     0,    99,  -115,
    -115,     0,     0,   100,     0,   101,   102,    82,    83,    84,
      85,    86,    87,    88,    89,     0,     0,     0,    90,     0,
       0,     0,    91,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,     0,    99,    58,    59,   103,   264,   100,   265,
     101,   102,    82,    83,    84,    85,    86,    87,    88,    89,
       0,     0,     0,    90,     0,     0,     0,    91,     0,     0,
       0,     0,  -224,     0,     0,     0,     0,     0,  -224,    92,
      93,    94,    95,    96,    97,     0,    98,     0,    99,    58,
      59,   103,     0,   100,     0,   101,   102,    82,    83,    84,
      85,    86,    87,    88,    89,     0,     0,     0,    90,     0,
       0,     0,    91,     0,     0,     0,     0,   205,     0,     0,
       0,     0,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,     0,    99,    58,    59,   103,     0,   100,     0,
     101,   102,    82,    83,    84,    85,    86,    87,    88,    89,
       0,     0,     0,    90,     0,     0,     0,    91,     0,     0,
       0,     0,   215,     0,     0,     0,     0,     0,     0,    92,
      93,    94,    95,    96,    97,     0,    98,     0,    99,    58,
      59,   103,     0,   100,     0,   101,   102,    82,    83,    84,
      85,    86,    87,    88,    89,     0,     0,     0,    90,     0,
       0,     0,    91,     0,     0,     0,     0,   307,     0,     0,
       0,     0,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,     0,    99,    58,    59,   103,     0,   100,     0,
     101,   102,    82,    83,    84,    85,    86,    87,    88,    89,
       0,     0,     0,    90,     0,     0,     0,    91,     0,     0,
       0,     0,   330,     0,     0,     0,     0,     0,     0,    92,
      93,    94,    95,    96,    97,     0,    98,     0,    99,    58,
      59,   103,     0,   100,     0,   101,   102,    82,    83,    84,
      85,    86,    87,    88,    89,     0,     0,     0,    90,  -111,
       0,     0,    91,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,     0,    99,    58,    59,   103,     0,   100,     0,
     101,   102,    82,    83,    84,    85,    86,    87,    88,    89,
       0,     0,     0,    90,     0,     0,     0,    91,     0,     0,
       0,     0,   363,     0,     0,     0,     0,     0,     0,    92,
      93,    94,    95,    96,    97,     0,    98,     0,    99,    58,
      59,   103,     0,   100,     0,   101,   102,    82,    83,    84,
      85,    86,    87,    88,    89,     0,     0,     0,    90,     0,
       0,     0,    91,     0,     0,     0,     0,   366,     0,     0,
       0,     0,     0,     0,    92,    93,    94,    95,    96,    97,
       0,    98,     0,    99,    58,    59,   103,     0,   100,     0,
     101,   102,    82,    83,    84,    85,    86,    87,    88,    89,
       0,     0,     0,    90,     0,     0,     0,    91,     0,     0,
       0,   146,   147,   148,   149,     0,     0,     0,     0,    92,
      93,    94,    95,    96,    97,     0,    98,     0,    99,    58,
      59,   103,     0,   100,     0,   101,   102,   271,   272,   273,
     150,   151,   152,   153,   154,   155,   156,   157,     0,     0,
       0,     0,     0,     1,     2,     3,   146,   147,   148,   149,
       0,   274,     4,     0,     0,     0,    47,     0,     0,    48,
      49,     0,     0,     5,    58,    59,   103,     0,     0,     0,
      50,     0,     0,     0,    51,     0,     0,   152,   153,   154,
     155,   156,   157,     0,    52,     0,     0,    53,    54,     0,
      55,    56,    57,    58,    59,     0,    60,    61,    62,     6,
      63,    64,     0,     0,    78,     8,     0,    65,     0,    47,
     -17,    66,    48,    49,   163,   164,     0,     0,     0,     0,
       0,     0,     0,    50,     0,     0,     0,    51,     0,     0,
       0,     0,   166,   167,   168,   169,   170,    52,     0,     0,
      53,    54,     0,    55,    56,    57,    58,    59,     0,    60,
      61,    62,    47,    63,    64,    48,    49,     0,     0,     0,
      65,   220,     0,     0,    66,     0,    50,     0,     0,     0,
      51,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      52,     0,     0,    53,    54,     0,    55,    56,    57,    58,
      59,     0,    60,    61,    62,    47,    63,    64,    48,    49,
       0,     0,     0,    65,   223,     0,     0,    66,     0,    50,
       0,     0,     0,    51,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    52,     0,     0,    53,    54,     0,    55,
      56,    57,    58,    59,     0,    60,    61,    62,    47,    63,
      64,    48,    49,     0,     0,     0,    65,     0,     0,     0,
      66,     0,    50,     0,     0,     0,    51,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    52,     0,     0,    53,
      54,     0,    55,   249,    57,    58,    59,     0,    60,    61,
      62,     0,    63,    64,  -225,  -225,  -225,  -225,     0,    65,
     271,   272,   273,    66,     0,     0,   146,   147,   148,   149,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,   161,   162,     0,   274,  -225,  -225,   154,   155,   156,
     157,   163,   164,     0,     0,   150,   151,   152,   153,   154,
     155,   156,   157,   160,   161,   162,     0,     0,   165,   166,
     167,   168,   169,   170,   163,   164,   160,     0,   162,     0,
       0,     0,     0,     0,     0,     0,     0,   163,   164,     0,
       0,     0,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,   166,   167,   168,   169,   170
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-265)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-225)))

static const yytype_int16 yycheck[] =
{
      28,     5,    81,    94,   178,    96,   180,    49,    37,    11,
       6,     7,   276,    54,    83,    13,    45,    50,    54,    11,
      50,    81,    50,    24,    83,    91,     0,    79,    37,    51,
      99,    83,    98,    35,    38,    39,    45,    65,     0,    43,
      99,    63,    64,    35,    22,    25,    26,    27,    28,    11,
      46,    13,     0,   308,    87,    76,   320,    87,    79,    40,
      41,   102,    90,    11,    81,    13,   102,   322,   101,    97,
      98,    99,    89,    35,    54,    55,    56,    57,    58,    59,
      60,    61,    80,     0,    85,    86,    79,    35,    81,    93,
      77,    98,   134,   100,    11,    12,    13,   106,    68,   103,
     128,   129,    79,    20,    38,   133,    83,    22,    42,   106,
      71,   139,   140,   141,    31,    99,   125,    94,    80,    53,
     100,   130,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    80,   130,    23,    69,    70,    89,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   177,
      67,    40,    41,    87,    23,    72,    73,   185,   186,   188,
      29,   189,    99,    63,    23,   194,    51,   195,   259,    99,
      29,   173,    83,    84,    74,    75,   204,   101,   102,   188,
     208,   173,    98,   212,   100,   194,   360,   361,    51,     0,
      99,   200,    92,    93,    94,    95,    96,    82,    88,    89,
      11,    12,    13,   212,    89,    90,    19,    20,    21,    20,
      91,   173,    53,    83,    11,    12,    13,   308,    22,    82,
      31,   217,   250,    20,    32,   173,    89,    90,    69,    70,
      43,   322,    99,    22,    31,   264,    99,   265,    11,    12,
      13,    22,    54,   271,   272,   273,   274,    20,   257,    98,
      91,   100,   261,    22,   100,   264,    67,   266,    31,   323,
     257,   325,    73,    78,   261,   293,    91,    98,    42,   266,
      67,    98,    22,   302,    71,   303,    73,   306,   282,    53,
     289,    58,    59,    60,    61,   314,    29,    25,    26,    27,
      28,    98,   289,   302,    67,    69,    70,   306,   100,    15,
      73,   101,    49,   312,    83,   314,   315,   102,    91,   338,
      94,    95,    96,   342,    36,   312,    54,    55,    56,    57,
      58,    59,    60,    61,    87,    83,    98,    98,   337,   338,
      98,   340,    45,   342,    87,   364,   345,    36,   367,   100,
     337,   100,    30,   340,   173,   328,   328,   351,   345,   377,
     329,   301,   362,   362,   353,   364,   365,   177,   367,   310,
     315,    71,   100,   120,   140,   362,   210,   376,   365,   275,
     379,    -1,   280,    25,    26,    27,    28,    -1,    -1,   376,
      -1,    -1,   379,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    18,    -1,
      -1,    -1,    22,    55,    56,    57,    58,    59,    60,    61,
      30,    31,    32,    33,    34,    35,    -1,    37,    -1,    39,
      -1,    -1,    -1,    -1,    44,    -1,    46,    47,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      -1,    -1,    -1,    18,    -1,    48,    -1,    22,    51,    52,
      92,    93,    94,    95,    96,    30,    31,    32,    33,    34,
      35,    -1,    37,    66,    39,    85,    86,    87,    -1,    44,
      -1,    46,    47,    76,    -1,    -1,    79,    80,    98,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,
     103,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      85,    86,    87,    14,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,    -1,    98,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    39,    -1,
      -1,    -1,    -1,    44,    -1,    46,    47,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    57,    58,    59,    60,
      61,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    -1,    -1,    -1,    18,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    85,    86,    87,    -1,    30,    31,
      32,    33,    34,    35,    -1,    37,    -1,    39,    -1,    -1,
      -1,    43,    44,    45,    46,    47,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    25,    26,    27,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    -1,
      37,    -1,    39,    85,    86,    87,    -1,    44,    -1,    46,
      47,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    -1,    22,    -1,    18,
      25,    26,    27,    28,    23,    -1,    -1,    -1,    85,    86,
      87,    30,    31,    32,    33,    34,    35,   100,    37,    -1,
      39,    40,    41,    -1,    -1,    44,    -1,    46,    47,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,    85,    86,    87,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    39,    40,
      41,    -1,    -1,    44,    -1,    46,    47,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    39,    85,    86,    87,    43,    44,    45,
      46,    47,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    39,    85,
      86,    87,    -1,    44,    -1,    46,    47,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    39,    85,    86,    87,    -1,    44,    -1,
      46,    47,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    39,    85,
      86,    87,    -1,    44,    -1,    46,    47,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    39,    85,    86,    87,    -1,    44,    -1,
      46,    47,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    39,    85,
      86,    87,    -1,    44,    -1,    46,    47,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    39,    85,    86,    87,    -1,    44,    -1,
      46,    47,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    39,    85,
      86,    87,    -1,    44,    -1,    46,    47,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    39,    85,    86,    87,    -1,    44,    -1,
      46,    47,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    18,    -1,    -1,
      -1,    25,    26,    27,    28,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    39,    85,
      86,    87,    -1,    44,    -1,    46,    47,    19,    20,    21,
      54,    55,    56,    57,    58,    59,    60,    61,    -1,    -1,
      -1,    -1,    -1,    11,    12,    13,    25,    26,    27,    28,
      -1,    43,    20,    -1,    -1,    -1,    48,    -1,    -1,    51,
      52,    -1,    -1,    31,    85,    86,    87,    -1,    -1,    -1,
      62,    -1,    -1,    -1,    66,    -1,    -1,    56,    57,    58,
      59,    60,    61,    -1,    76,    -1,    -1,    79,    80,    -1,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    67,
      92,    93,    -1,    -1,    72,    73,    -1,    99,    -1,    48,
      78,   103,    51,    52,    74,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    92,    93,    94,    95,    96,    76,    -1,    -1,
      79,    80,    -1,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    48,    92,    93,    51,    52,    -1,    -1,    -1,
      99,   100,    -1,    -1,   103,    -1,    62,    -1,    -1,    -1,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    79,    80,    -1,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    48,    92,    93,    51,    52,
      -1,    -1,    -1,    99,   100,    -1,    -1,   103,    -1,    62,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    -1,    -1,    79,    80,    -1,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    48,    92,
      93,    51,    52,    -1,    -1,    -1,    99,    -1,    -1,    -1,
     103,    -1,    62,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,    -1,    79,
      80,    -1,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    25,    26,    27,    28,    -1,    99,
      19,    20,    21,   103,    -1,    -1,    25,    26,    27,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    64,    65,    -1,    43,    56,    57,    58,    59,    60,
      61,    74,    75,    -1,    -1,    54,    55,    56,    57,    58,
      59,    60,    61,    63,    64,    65,    -1,    -1,    91,    92,
      93,    94,    95,    96,    74,    75,    63,    -1,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    75,    -1,
      -1,    -1,    92,    93,    94,    95,    96,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    94,    95,    96
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    11,    12,    13,    20,    31,    67,    71,    73,   105,
     106,   107,   108,   110,   111,   115,   116,   118,   119,   121,
     122,    81,   134,    79,    81,   114,    81,    89,   117,   114,
     114,    81,     0,   108,   115,   107,    77,    22,    38,    42,
      53,    69,    70,    87,   120,    22,    68,    48,    51,    52,
      62,    66,    76,    79,    80,    82,    83,    84,    85,    86,
      88,    89,    90,    92,    93,    99,   103,   166,   168,   169,
     170,   171,   172,   173,   175,   177,    91,   120,    72,   112,
     109,   110,     3,     4,     5,     6,     7,     8,     9,    10,
      14,    18,    30,    31,    32,    33,    34,    35,    37,    39,
      44,    46,    47,    87,   119,   121,   135,   136,   137,   138,
     139,   140,   142,   147,   148,   150,   158,   165,   175,   178,
     179,   180,   183,   184,   185,   186,   117,   123,   117,   117,
     135,   113,   114,    99,    99,   173,   174,   166,   168,    99,
      99,    99,   168,   168,   166,    89,    25,    26,    27,    28,
      54,    55,    56,    57,    58,    59,    60,    61,   156,   157,
      63,    64,    65,    74,    75,    91,    92,    93,    94,    95,
      96,   172,    91,   107,    83,   143,   144,   145,    99,   143,
      99,   143,    79,    83,   154,   155,   155,   155,   166,   117,
      94,   153,   154,   182,    22,   154,   166,   166,   166,   117,
     159,   160,   160,   160,   117,    23,   136,   180,    24,   175,
     188,    99,    22,   166,   166,    23,    91,    98,   166,   173,
     100,   166,   176,   100,   176,   166,   100,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   168,   168,   168,
     168,   168,   168,   168,   168,   168,   168,   168,   112,    83,
     146,   166,   166,   167,   167,   166,   166,   135,   166,    54,
      22,   135,   166,    22,    43,    45,   135,   161,   162,   163,
     166,    19,    20,    21,    43,   166,   189,   190,    22,   187,
     187,    50,    87,   124,   125,   126,   127,   128,   129,   135,
     114,   100,   100,    98,   100,   100,   100,    78,    91,   166,
      98,    98,    16,    17,   149,   154,   181,    23,    40,    41,
     151,   152,   135,   166,    22,    98,   166,   166,   166,   166,
     189,   190,    29,   191,   192,   191,   117,   100,   101,    98,
      23,   166,    83,   141,   146,   167,   141,   135,   166,    15,
     135,   153,   102,    23,   152,   135,   163,   153,    23,   192,
      23,    49,   130,   131,   132,   127,   128,    50,   129,    91,
      98,    98,   135,    23,   102,   135,    23,   102,   117,    36,
     133,   132,    83,   167,   167,   149,   135,    45,   164,   135,
      87,   100,   100,   166
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;


/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 500 "gram.y"
    {
                     if (error_count == 0) {
                             if (genstmt.head) {
                                     genstmt.tail->next = (yyvsp[(1) - (1)].stmtlist).head;
                                     genstmt.tail = (yyvsp[(1) - (1)].stmtlist).tail;
                             } else
                                     genstmt = (yyvsp[(1) - (1)].stmtlist);
                             optimize_tree(genstmt.head);
                             if (error_count)
                                     YYERROR;
                             mark(genstmt.head);
                             if (error_count)
                                     YYERROR;
                             apply_deferred_init();
                             dataseg_layout();
                             if (optimization_level)
                                     regex_layout();
                             compile_tree(genstmt.head);
                             if (!optimization_level)
                                     regex_layout();
                     }
             }
    break;

  case 4:
/* Line 1787 of yacc.c  */
#line 526 "gram.y"
    {
                     (yyval.stmtlist) = (yyvsp[(2) - (3)].stmtlist);
             }
    break;

  case 5:
/* Line 1787 of yacc.c  */
#line 532 "gram.y"
    {
                     (yyval.stmtlist).head = (yyval.stmtlist).tail = (yyvsp[(1) - (1)].node);
             }
    break;

  case 7:
/* Line 1787 of yacc.c  */
#line 537 "gram.y"
    {
                     if ((yyvsp[(2) - (2)].node)) {
                             if ((yyvsp[(1) - (2)].stmtlist).tail) 
                                     (yyvsp[(1) - (2)].stmtlist).tail->next = (yyvsp[(2) - (2)].node);
                             else
                                     (yyvsp[(1) - (2)].stmtlist).head = (yyvsp[(2) - (2)].node);
                             (yyvsp[(1) - (2)].stmtlist).tail = (yyvsp[(2) - (2)].node);
                     }
                     (yyval.stmtlist) = (yyvsp[(1) - (2)].stmtlist);
             }
    break;

  case 8:
/* Line 1787 of yacc.c  */
#line 548 "gram.y"
    {
                     if ((yyvsp[(2) - (2)].stmtlist).tail) {
                             if ((yyvsp[(1) - (2)].stmtlist).tail) {
                                     (yyval.stmtlist).head = (yyvsp[(1) - (2)].stmtlist).head;
                                     (yyvsp[(1) - (2)].stmtlist).tail->next = (yyvsp[(2) - (2)].stmtlist).head;
                                     (yyval.stmtlist).tail = (yyvsp[(2) - (2)].stmtlist).tail;
                             } else
                                     (yyval.stmtlist) = (yyvsp[(2) - (2)].stmtlist);
                     } 
             }
    break;

  case 9:
/* Line 1787 of yacc.c  */
#line 561 "gram.y"
    {
                     (yyval.stmtlist).head = (yyval.stmtlist).tail = NULL;
             }
    break;

  case 10:
/* Line 1787 of yacc.c  */
#line 565 "gram.y"
    {
                     (yyval.stmtlist) = (yyvsp[(4) - (6)].stmtlist);
                     pop_top_module();
             }
    break;

  case 11:
/* Line 1787 of yacc.c  */
#line 572 "gram.y"
    {
                     parse_warning(_("missing module declaration"));
             }
    break;

  case 13:
/* Line 1787 of yacc.c  */
#line 579 "gram.y"
    {
		     if (top_module->dclname)
                             parse_error_locus(&(yylsp[(2) - (3)]).beg,
                                               _("duplicate module declaration"));
		     else
			     top_module->dclname = (yyvsp[(2) - (3)].literal)->text;
	     }
    break;

  case 14:
/* Line 1787 of yacc.c  */
#line 587 "gram.y"
    {
		     if (top_module->dclname)
                             parse_error_locus(&(yylsp[(2) - (4)]).beg,
                                               _("duplicate module declaration"));
		     else {
			     if (((yyvsp[(3) - (4)].number) & (SYM_STATIC|SYM_PUBLIC)) == 0)
                                     parse_error_locus(&(yylsp[(3) - (4)]).beg,
                                                       _("invalid module declaration"));
			     top_module->dclname = (yyvsp[(2) - (4)].literal)->text;
			     top_module->flags = (yyvsp[(3) - (4)].number);
		     }
	     }
    break;

  case 15:
/* Line 1787 of yacc.c  */
#line 602 "gram.y"
    {
                     require_module((yyvsp[(2) - (2)].literal)->text, NULL);
             }
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 606 "gram.y"
    {
                     require_module((yyvsp[(2) - (5)].literal)->text, (yyvsp[(4) - (5)].import_rule_list).head);
             }
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 613 "gram.y"
    {
                     lex_bye();
             }
    break;

  case 19:
/* Line 1787 of yacc.c  */
#line 619 "gram.y"
    {
                     struct import_rule *rule = import_rule_create((yyvsp[(1) - (1)].literal));
                     (yyval.import_rule_list).head = (yyval.import_rule_list).tail = rule;
             }
    break;

  case 20:
/* Line 1787 of yacc.c  */
#line 624 "gram.y"
    {
                     struct import_rule *rule = import_rule_create((yyvsp[(3) - (3)].literal));
                     (yyval.import_rule_list).tail->next = rule;
                     (yyval.import_rule_list).tail = rule;
             }
    break;

  case 23:
/* Line 1787 of yacc.c  */
#line 636 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_progdecl, &(yylsp[(1) - (5)]).beg);
		     (yyval.node)->v.progdecl.tag = (yyvsp[(2) - (5)].state);
		     (yyval.node)->v.progdecl.auto_count = forget_autos(PARMCOUNT(),
							      0, 0);
		     (yyval.node)->v.progdecl.tree = (yyvsp[(4) - (5)].stmtlist).head;
		     
		     outer_context = inner_context = context_none;
		     state_tag = smtp_state_none;
	     }
    break;

  case 24:
/* Line 1787 of yacc.c  */
#line 647 "gram.y"
    {
		     static NODE *progspecial[2];
		     NODE *np = progspecial[(yyvsp[(1) - (4)].progspecial).code];
		     
		     if (!np) {
                             np = alloc_node(node_type_progdecl, &(yylsp[(1) - (4)]).beg);
			     (yyval.node) = progspecial[(yyvsp[(1) - (4)].progspecial).code] = np;
			     np->v.progdecl.tag = state_tag;
			     np->v.progdecl.tree = (yyvsp[(3) - (4)].stmtlist).head;
			     np->v.progdecl.auto_count = 0;
		     } else {
			     NODE *cur;
			     for (cur = np->v.progdecl.tree; cur->next;
				  cur = cur->next)
				     ;
			     cur->next = (yyvsp[(3) - (4)].stmtlist).head;
			     (yyval.node) = NULL;
		     }
				     
		     np->v.progdecl.auto_count = forget_autos(PARMCOUNT(),
							      np->v.progdecl.auto_count,
							      0);
		     outer_context = inner_context = context_none;
		     state_tag = smtp_state_none;
	     }
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 673 "gram.y"
    {
		     if ((yyvsp[(1) - (6)].number) & SYM_PRECIOUS)
                             parse_error_locus(&(yylsp[(2) - (6)]).beg,
					       _("precious used with func"));
		     if (((yyvsp[(1) - (6)].number) & (SYM_STATIC|SYM_PUBLIC)) ==
			 (SYM_STATIC|SYM_PUBLIC))
                             parse_error_locus(&(yylsp[(2) - (6)]).beg,
					       _("`static' and `public' "
						 "used together"));
		     func->sym.flags = (yyvsp[(1) - (6)].number);
		     func->node = (yyvsp[(5) - (6)].stmtlist).head;
                     (yyval.node) = declare_function(func, &(yylsp[(2) - (6)]).beg,
			   forget_autos(PARMCOUNT() + FUNC_HIDDEN_ARGS(func),
					0, FUNC_HIDDEN_ARGS(func)));
		     outer_context = inner_context = context_none;
		     func = NULL;
	     }
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 691 "gram.y"
    {
		     (yyval.node) = NULL;
	     }
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 695 "gram.y"
    {
		     (yyval.node) = NULL;
	     }
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 699 "gram.y"
    {
		     (yyval.node) = NULL;
	     }
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 705 "gram.y"
    {
		     state_tag = smtp_state_begin;
		     outer_context = inner_context = context_handler;
		     (yyval.progspecial).code = PS_BEGIN;
	     }
    break;

  case 30:
/* Line 1787 of yacc.c  */
#line 711 "gram.y"
    {
		     state_tag = smtp_state_end;
		     outer_context = inner_context = context_handler;
		     (yyval.progspecial).code = PS_END;
	     }
    break;

  case 32:
/* Line 1787 of yacc.c  */
#line 720 "gram.y"
    {
		     (yyval.literal) = literal_lookup((yyvsp[(1) - (1)].var)->sym.name);
	     }
    break;

  case 33:
/* Line 1787 of yacc.c  */
#line 726 "gram.y"
    {
		     struct variable *var;
		     
		     if (((yyvsp[(1) - (3)].number) & (SYM_STATIC|SYM_PUBLIC))
			 == (SYM_STATIC|SYM_PUBLIC))
                             parse_error_locus(&(yylsp[(1) - (3)]).beg,
                                               _("`static' and `public' "
					   "used together"));
		     var = vardecl((yyvsp[(3) - (3)].literal)->text, (yyvsp[(2) - (3)].type), storage_extern, NULL);
		     if (!var) 
			     YYERROR;
		     var->sym.flags |= (yyvsp[(1) - (3)].number);
	     }
    break;

  case 34:
/* Line 1787 of yacc.c  */
#line 740 "gram.y"
    {
                     struct value value;
                     struct variable *var;

		     if (((yyvsp[(1) - (4)].number) & (SYM_STATIC|SYM_PUBLIC))
			 == (SYM_STATIC|SYM_PUBLIC))
                             parse_error_locus(&(yylsp[(1) - (4)]).beg,
                                               _("`static' and `public' "
					   "used together"));
		     
                     var = vardecl((yyvsp[(3) - (4)].literal)->text, (yyvsp[(2) - (4)].type), storage_extern, NULL);
                     if (!var)
                             YYERROR;
                     var->sym.flags |= (yyvsp[(1) - (4)].number);

                     if (optimization_level)
                             optimize((yyvsp[(4) - (4)].node));
                     value.type = node_type((yyvsp[(4) - (4)].node));

                     switch ((yyvsp[(4) - (4)].node)->type) {
                     case node_type_string:
                             value.v.literal = (yyvsp[(4) - (4)].node)->v.literal;
                             break;

                     case node_type_number:
                             value.v.number = (yyvsp[(4) - (4)].node)->v.number;
                             break;

                     default:
                             yyerror("initializer element is not constant");
                             YYERROR;

		     }
		     if (initialize_variable(var, &value, &(yyvsp[(4) - (4)].node)->locus))
			     YYERROR;
	     }
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 778 "gram.y"
    {
		     struct value value;
		     
		     if (optimization_level)
			     optimize((yyvsp[(3) - (3)].node));
		     value.type = node_type((yyvsp[(3) - (3)].node));
		     
		     switch ((yyvsp[(3) - (3)].node)->type) {
		     case node_type_string:
			     value.v.literal = (yyvsp[(3) - (3)].node)->v.literal;
			     break;

		     case node_type_number:
			     value.v.number = (yyvsp[(3) - (3)].node)->v.number;
			     break;

		     default:
			     yyerror("initializer element is not constant");
			     YYERROR;
		     }
                     if (!externdecl((yyvsp[(2) - (3)].literal)->text, &value, &(yylsp[(1) - (3)]).beg))
			     YYERROR;
	     }
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 804 "gram.y"
    {
                     (yyval.number) = 0;
             }
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 808 "gram.y"
    {
                     if ((yyvsp[(1) - (2)].number) & (yyvsp[(2) - (2)].number))
                             parse_warning(_("duplicate `%s'"),
                                           symbit_to_qualifier((yyvsp[(2) - (2)].number)));
                     (yyval.number) = (yyvsp[(1) - (2)].number) | (yyvsp[(2) - (2)].number);
             }
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 817 "gram.y"
    {
                     (yyval.number) = SYM_PRECIOUS;
             }
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 821 "gram.y"
    {
                     (yyval.number) = SYM_STATIC;
             }
    break;

  case 40:
/* Line 1787 of yacc.c  */
#line 825 "gram.y"
    {
                     (yyval.number) = SYM_PUBLIC;
             }
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 833 "gram.y"
    {
		     struct value value;
		     struct variable *pvar;

		     if ((yyvsp[(1) - (4)].number) & SYM_PRECIOUS)
                             parse_error_locus(&(yylsp[(1) - (4)]).beg,
					       _("precious used with const"));
		     if (((yyvsp[(1) - (4)].number) & (SYM_STATIC|SYM_PUBLIC)) ==
			 (SYM_STATIC|SYM_PUBLIC))
                             parse_error_locus(&(yylsp[(1) - (4)]).beg,
					       _("`static' and `public' "
						 "used together"));
		     /* FIXME: This is necessary because constants can be
			referred to the same way as variables. */
		     if (pvar = variable_lookup((yyvsp[(3) - (4)].literal)->text)) {
			     parse_warning(_("constant name `%s' clashes with a variable name"),
					   (yyvsp[(3) - (4)].literal)->text);
			     parse_warning_locus(&pvar->sym.locus,
						 _("this is the location of the "
						   "previous definition"));
		     }
			     
		     if (optimization_level)
			     optimize((yyvsp[(4) - (4)].node));
		     
		     switch ((yyvsp[(4) - (4)].node)->type) {
		     case node_type_string:
			     value.type = dtype_string;
			     value.v.literal = (yyvsp[(4) - (4)].node)->v.literal;
			     break;

		     case node_type_number:
			     value.type = dtype_number;
			     value.v.number = (yyvsp[(4) - (4)].node)->v.number;
			     break;
			     
		     default:
			     yyerror(_("initializer element is not constant"));
			     YYERROR;
		     }
                     define_constant((yyvsp[(3) - (4)].literal)->text, &value, (yyvsp[(1) - (4)].number), &(yylsp[(2) - (4)]).beg);
		     (yyval.node) = NULL;
	     }
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 879 "gram.y"
    {
		     define_exception((yyvsp[(2) - (2)].literal), &(yylsp[(1) - (2)]).beg);
	     }
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 885 "gram.y"
    {
		     data_type_t *ptypes = NULL;
		     
		     if ((yyvsp[(3) - (6)].parmlist).count) {
			     int i;
			     struct parmtype *p;
			     
			     ptypes = xmalloc((yyvsp[(3) - (6)].parmlist).count * sizeof *ptypes);
			     for (i = 0, p = (yyvsp[(3) - (6)].parmlist).head; p; i++) {
				     struct parmtype *next = p->next;
				     ptypes[i] = p->type;
				     free(p);
				     p = next;
			     }
		     }

		     (yyval.function) = func = function_install((yyvsp[(1) - (6)].literal)->text,
						  (yyvsp[(3) - (6)].parmlist).count, (yyvsp[(3) - (6)].parmlist).optcount,
						  (yyvsp[(3) - (6)].parmlist).varargs,
						  ptypes, (yyvsp[(6) - (6)].type),
                                                  &(yylsp[(1) - (6)]).beg);
		     if ((yyvsp[(5) - (6)].list)) {
			     mu_list_foreach((yyvsp[(5) - (6)].list), _create_alias, (yyval.function));
			     mu_list_destroy(&(yyvsp[(5) - (6)].list));
		     }
		     outer_context = inner_context = context_function;
	     }
    break;

  case 44:
/* Line 1787 of yacc.c  */
#line 915 "gram.y"
    {
                     (yyval.parmlist).count = (yyval.parmlist).optcount = 0;
                     (yyval.parmlist).varargs = 0;
             }
    break;

  case 47:
/* Line 1787 of yacc.c  */
#line 924 "gram.y"
    {
                     (yyval.parmlist).count = (yyval.parmlist).optcount = 0;
                     (yyval.parmlist).varargs = 1;
             }
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 929 "gram.y"
    {
                     (yyvsp[(1) - (3)].parmlist).count += (yyvsp[(3) - (3)].parmlist).count;
                     (yyvsp[(1) - (3)].parmlist).optcount = (yyvsp[(3) - (3)].parmlist).count;
                     (yyvsp[(1) - (3)].parmlist).varargs = (yyvsp[(3) - (3)].parmlist).varargs;
                     if ((yyvsp[(1) - (3)].parmlist).tail) 
                             (yyvsp[(1) - (3)].parmlist).tail->next = (yyvsp[(3) - (3)].parmlist).head;
                     else
                             (yyvsp[(1) - (3)].parmlist).head = (yyvsp[(3) - (3)].parmlist).head;
                     (yyvsp[(1) - (3)].parmlist).tail = (yyvsp[(3) - (3)].parmlist).tail;
                     (yyval.parmlist) = (yyvsp[(1) - (3)].parmlist);
             }
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 943 "gram.y"
    {
                     (yyval.parmlist).count = 0;
                     (yyval.parmlist).varargs = 0;
                     (yyval.parmlist).head = (yyval.parmlist).tail = NULL;
             }
    break;

  case 51:
/* Line 1787 of yacc.c  */
#line 952 "gram.y"
    {
		     (yyval.parmlist).count = 1;
		     (yyval.parmlist).varargs = 0;
                     (yyval.parmlist).optcount = 0;
		     (yyval.parmlist).head = (yyval.parmlist).tail = (yyvsp[(1) - (1)].parm);
	     }
    break;

  case 52:
/* Line 1787 of yacc.c  */
#line 959 "gram.y"
    {
                     (yyvsp[(1) - (3)].parmlist).count++;
                     (yyvsp[(1) - (3)].parmlist).tail->next = (yyvsp[(3) - (3)].parm);
                     (yyvsp[(1) - (3)].parmlist).tail = (yyvsp[(3) - (3)].parm);
                     (yyval.parmlist) = (yyvsp[(1) - (3)].parmlist);
             }
    break;

  case 54:
/* Line 1787 of yacc.c  */
#line 969 "gram.y"
    {
                     (yyvsp[(1) - (3)].parmlist).varargs = 1;
                     (yyval.parmlist) = (yyvsp[(1) - (3)].parmlist);
             }
    break;

  case 55:
/* Line 1787 of yacc.c  */
#line 976 "gram.y"
    {
		     if (!vardecl((yyvsp[(2) - (2)].literal)->text, (yyvsp[(1) - (2)].type), storage_param, NULL))
			     YYERROR;
		     (yyval.parm) = xmalloc(sizeof *(yyval.parm));
		     (yyval.parm)->next = NULL;
		     (yyval.parm)->type = (yyvsp[(1) - (2)].type);
	     }
    break;

  case 56:
/* Line 1787 of yacc.c  */
#line 985 "gram.y"
    {
		     parse_warning_locus(&(yylsp[(1) - (1)]).beg,
					 _("unnamed formal parameters are deprecated"));
		     (yyval.parm) = xmalloc(sizeof *(yyval.parm));
		     (yyval.parm)->next = NULL;
		     (yyval.parm)->type = (yyvsp[(1) - (1)].type);
	     }
    break;

  case 57:
/* Line 1787 of yacc.c  */
#line 995 "gram.y"
    {
                     (yyval.list) = NULL;
             }
    break;

  case 59:
/* Line 1787 of yacc.c  */
#line 1002 "gram.y"
    {
                     mu_list_create(&(yyval.list));
                     mu_list_append((yyval.list), (yyvsp[(1) - (1)].literal));
             }
    break;

  case 60:
/* Line 1787 of yacc.c  */
#line 1007 "gram.y"
    {
                     mu_list_append((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].literal));
                     (yyval.list) = (yyvsp[(1) - (2)].list);
             }
    break;

  case 61:
/* Line 1787 of yacc.c  */
#line 1014 "gram.y"
    {
                     (yyval.literal) = (yyvsp[(2) - (2)].literal);
             }
    break;

  case 62:
/* Line 1787 of yacc.c  */
#line 1020 "gram.y"
    {
                     (yyval.type) = dtype_unspecified;
             }
    break;

  case 63:
/* Line 1787 of yacc.c  */
#line 1024 "gram.y"
    {
		     (yyval.type) = (yyvsp[(2) - (2)].type);
	     }
    break;

  case 64:
/* Line 1787 of yacc.c  */
#line 1030 "gram.y"
    {
		     (yyval.state) = string_to_state((yyvsp[(1) - (1)].literal)->text);
		     if ((yyval.state) == smtp_state_none)
                             parse_error_locus(&(yylsp[(1) - (1)]).beg,
                                        _("unknown smtp state tag: %s"),
					 (yyvsp[(1) - (1)].literal)->text);
		     state_tag = (yyval.state);
		     outer_context = inner_context = context_handler;
	     }
    break;

  case 65:
/* Line 1787 of yacc.c  */
#line 1042 "gram.y"
    {
                     if ((yyvsp[(1) - (1)].node)) 
                             (yyvsp[(1) - (1)].node)->next = NULL;
                     (yyval.stmtlist).head = (yyval.stmtlist).tail = (yyvsp[(1) - (1)].node);
             }
    break;

  case 66:
/* Line 1787 of yacc.c  */
#line 1048 "gram.y"
    {
                     if ((yyvsp[(2) - (2)].node)) {
                             if ((yyvsp[(1) - (2)].stmtlist).tail) 
                                     (yyvsp[(1) - (2)].stmtlist).tail->next = (yyvsp[(2) - (2)].node);
                             else
                                     (yyvsp[(1) - (2)].stmtlist).head = (yyvsp[(2) - (2)].node);
                             (yyvsp[(1) - (2)].stmtlist).tail = (yyvsp[(2) - (2)].node);
                     }
                     (yyval.stmtlist) = (yyvsp[(1) - (2)].stmtlist);
             }
    break;

  case 74:
/* Line 1787 of yacc.c  */
#line 1068 "gram.y"
    {
		     if (node_type((yyvsp[(1) - (1)].node)) != dtype_unspecified)
			     parse_warning(_("return from %s is ignored"),
					   (yyvsp[(1) - (1)].node)->type == node_type_builtin ?
					   (yyvsp[(1) - (1)].node)->v.builtin.builtin->name :
					   (yyvsp[(1) - (1)].node)->v.call.func->sym.name);
	     }
    break;

  case 78:
/* Line 1787 of yacc.c  */
#line 1081 "gram.y"
    {
		     struct variable *var;
		     data_type_t t = node_type((yyvsp[(3) - (3)].node));

		     if (t == dtype_unspecified) {
                             parse_error_locus(&(yylsp[(3) - (3)]).beg,
                                       _("unspecified value not ignored as "
					   "it should be"));
			     YYERROR;
		     }

		     var = variable_lookup((yyvsp[(2) - (3)].literal)->text);
		     if (!var) {
                             var = vardecl((yyvsp[(2) - (3)].literal)->text, t, storage_auto, &(yylsp[(1) - (3)]).beg);
			     if (!var) 
				     YYERROR;
		     }
                     (yyval.node) = create_asgn_node(var, (yyvsp[(3) - (3)].node), &(yylsp[(1) - (3)]).beg);
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 79:
/* Line 1787 of yacc.c  */
#line 1105 "gram.y"
    {
		     if (!vardecl((yyvsp[(2) - (2)].literal)->text, (yyvsp[(1) - (2)].type), storage_auto, NULL))
			     YYERROR;
		     (yyval.node) = NULL;
	     }
    break;

  case 80:
/* Line 1787 of yacc.c  */
#line 1111 "gram.y"
    {
		     struct variable *var = vardecl((yyvsp[(2) - (3)].literal)->text, (yyvsp[(1) - (3)].type),
						    storage_auto, NULL);
		     if (!var)
			     YYERROR;
                     (yyval.node) = create_asgn_node(var, (yyvsp[(3) - (3)].node), &(yylsp[(1) - (3)]).beg);
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 81:
/* Line 1787 of yacc.c  */
#line 1123 "gram.y"
    {
		     if (inner_context == context_handler) {
			     if (state_tag == smtp_state_begin)
                                     parse_error_locus(&(yylsp[(1) - (1)]).beg,
                                                _("Sendmail action is not "
						   "allowed in begin block"));
			     else if (state_tag == smtp_state_end)
                                     parse_error_locus(&(yylsp[(1) - (1)]).beg,
                                               _("Sendmail action is not "
						   "allowed in end block"));
		     }
	     }
    break;

  case 82:
/* Line 1787 of yacc.c  */
#line 1136 "gram.y"
    {
		     if (inner_context == context_handler
			 && state_tag == smtp_state_end)
                            parse_error_locus(&(yylsp[(1) - (1)]).beg,
                                          _("header action is not allowed "
					   "in end block"));
	     }
    break;

  case 83:
/* Line 1787 of yacc.c  */
#line 1144 "gram.y"
    {
                    (yyval.node) = alloc_node(node_type_noop, &(yylsp[(1) - (1)]).beg);
	     }
    break;

  case 84:
/* Line 1787 of yacc.c  */
#line 1148 "gram.y"
    {
                    (yyval.node) = alloc_node(node_type_echo, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.node = cast_to(dtype_string, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 85:
/* Line 1787 of yacc.c  */
#line 1156 "gram.y"
    {
		     if ((yyvsp[(2) - (2)].ret).code || (yyvsp[(2) - (2)].ret).xcode || (yyvsp[(2) - (2)].ret).message)
			     parse_warning(_("arguments are ignored for accept"));
                     (yyval.node) = alloc_node(node_type_result, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_ACCEPT;
	     }
    break;

  case 86:
/* Line 1787 of yacc.c  */
#line 1164 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_result, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_REJECT;
	     }
    break;

  case 87:
/* Line 1787 of yacc.c  */
#line 1170 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_result, &(yylsp[(1) - (8)]).beg);
		     (yyval.node)->v.ret.stat = SMFIS_REJECT;
		     (yyval.node)->v.ret.code = (yyvsp[(3) - (8)].node) ? cast_to(dtype_string, (yyvsp[(3) - (8)].node)) : NULL;
		     (yyval.node)->v.ret.xcode = (yyvsp[(5) - (8)].node) ? cast_to(dtype_string, (yyvsp[(5) - (8)].node)) : NULL;
		     (yyval.node)->v.ret.message = (yyvsp[(7) - (8)].node) ? cast_to(dtype_string, (yyvsp[(7) - (8)].node)) : NULL;
	     }
    break;

  case 88:
/* Line 1787 of yacc.c  */
#line 1178 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_result, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.ret = (yyvsp[(2) - (2)].ret);
		     (yyval.node)->v.ret.stat = SMFIS_TEMPFAIL;
	     }
    break;

  case 89:
/* Line 1787 of yacc.c  */
#line 1184 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_result, &(yylsp[(1) - (8)]).beg);
		     (yyval.node)->v.ret.stat = SMFIS_TEMPFAIL;
		     (yyval.node)->v.ret.code = (yyvsp[(3) - (8)].node) ? cast_to(dtype_string, (yyvsp[(3) - (8)].node)) : NULL;
		     (yyval.node)->v.ret.xcode = (yyvsp[(5) - (8)].node) ? cast_to(dtype_string, (yyvsp[(5) - (8)].node)) : NULL;
		     (yyval.node)->v.ret.message = (yyvsp[(7) - (8)].node) ? cast_to(dtype_string, (yyvsp[(7) - (8)].node)) : NULL;
	     }
    break;

  case 90:
/* Line 1787 of yacc.c  */
#line 1192 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_result, &(yylsp[(1) - (1)]).beg);
		     memset(&(yyval.node)->v.ret, 0, sizeof (yyval.node)->v.ret);
		     (yyval.node)->v.ret.stat = SMFIS_CONTINUE;
	     }
    break;

  case 91:
/* Line 1787 of yacc.c  */
#line 1198 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_result, &(yylsp[(1) - (1)]).beg);
		     memset(&(yyval.node)->v.ret, 0, sizeof (yyval.node)->v.ret);
		     (yyval.node)->v.ret.stat = SMFIS_DISCARD;
	     }
    break;

  case 93:
/* Line 1787 of yacc.c  */
#line 1207 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_string, &(yylsp[(1) - (1)]).beg);
		     (yyval.node)->v.literal = (yyvsp[(1) - (1)].literal);
	     }
    break;

  case 94:
/* Line 1787 of yacc.c  */
#line 1216 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_header, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.hdr.opcode = header_add;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (3)].literal);
		     (yyval.node)->v.hdr.value = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 95:
/* Line 1787 of yacc.c  */
#line 1223 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_header, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.hdr.opcode = header_replace;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (3)].literal);
		     (yyval.node)->v.hdr.value = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 96:
/* Line 1787 of yacc.c  */
#line 1230 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_header, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.hdr.opcode = header_delete;
		     (yyval.node)->v.hdr.name = (yyvsp[(2) - (2)].literal);
		     (yyval.node)->v.hdr.value = NULL;
	     }
    break;

  case 97:
/* Line 1787 of yacc.c  */
#line 1239 "gram.y"
    {
                     memset(&(yyval.ret), 0, sizeof (yyval.ret));
             }
    break;

  case 99:
/* Line 1787 of yacc.c  */
#line 1246 "gram.y"
    {
                     (yyval.ret).code = alloc_node(node_type_string, &(yylsp[(1) - (1)]).beg);
		     (yyval.ret).code->v.literal = (yyvsp[(1) - (1)].literal);
		     (yyval.ret).xcode = NULL;
		     (yyval.ret).message = NULL;
	     }
    break;

  case 100:
/* Line 1787 of yacc.c  */
#line 1253 "gram.y"
    {
                     (yyval.ret).code = alloc_node(node_type_string, &(yylsp[(1) - (2)]).beg);
		     (yyval.ret).code->v.literal = (yyvsp[(1) - (2)].literal);
                     (yyval.ret).xcode = alloc_node(node_type_string, &(yylsp[(2) - (2)]).beg);
		     (yyval.ret).xcode->v.literal = (yyvsp[(2) - (2)].literal);
		     (yyval.ret).message = NULL;
	     }
    break;

  case 101:
/* Line 1787 of yacc.c  */
#line 1261 "gram.y"
    {
                     (yyval.ret).code = alloc_node(node_type_string, &(yylsp[(1) - (3)]).beg);
		     (yyval.ret).code->v.literal = (yyvsp[(1) - (3)].literal);
                     (yyval.ret).xcode = alloc_node(node_type_string, &(yylsp[(2) - (3)]).beg);
		     (yyval.ret).xcode->v.literal = (yyvsp[(2) - (3)].literal);
		     (yyval.ret).message = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 102:
/* Line 1787 of yacc.c  */
#line 1269 "gram.y"
    {
                     (yyval.ret).code = alloc_node(node_type_string, &(yylsp[(1) - (2)]).beg);
		     (yyval.ret).code->v.literal = (yyvsp[(1) - (2)].literal);
		     (yyval.ret).xcode = NULL;
		     (yyval.ret).message = cast_to(dtype_string, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 103:
/* Line 1787 of yacc.c  */
#line 1278 "gram.y"
    {
                     char buf[4];

                     if ((yyvsp[(1) - (1)].number) < 200 || (yyvsp[(1) - (1)].number) > 599) {
                             yyerror(_("invalid SMTP reply code"));
                             buf[0] = 0;
                     } else
                             snprintf(buf, sizeof(buf), "%lu", (yyvsp[(1) - (1)].number));
                     (yyval.literal) = string_alloc(buf, strlen(buf));
             }
    break;

  case 104:
/* Line 1787 of yacc.c  */
#line 1291 "gram.y"
    {
                     char buf[sizeof("5.999.999")];

                     /* RFC 1893:
                        The syntax of the new status codes is defined as:

                        status-code = class "." subject "." detail
                        class = "2"/"4"/"5"
                        subject = 1*3digit
                        detail = 1*3digit
                     */                        
                     if (((yyvsp[(1) - (5)].number) != 2 && (yyvsp[(1) - (5)].number) != 4 && (yyvsp[(1) - (5)].number) !=5)
                         || (yyvsp[(3) - (5)].number) > 999 || (yyvsp[(5) - (5)].number) > 999) {
                             yyerror(_("invalid extended reply code"));
                             buf[0] = 0;
                     } else
                             snprintf(buf, sizeof(buf), "%lu.%lu.%lu",
                                      (yyvsp[(1) - (5)].number), (yyvsp[(3) - (5)].number), (yyvsp[(5) - (5)].number));
                     (yyval.literal) = string_alloc(buf, strlen(buf));
             }
    break;

  case 108:
/* Line 1787 of yacc.c  */
#line 1319 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_if, &(yylsp[(1) - (5)]).beg);
		     (yyval.node)->v.cond.cond = (yyvsp[(2) - (5)].node);
		     (yyval.node)->v.cond.if_true = (yyvsp[(3) - (5)].stmtlist).head;
		     (yyval.node)->v.cond.if_false = (yyvsp[(4) - (5)].node);
	     }
    break;

  case 109:
/* Line 1787 of yacc.c  */
#line 1328 "gram.y"
    {
                     (yyval.node) = NULL;
             }
    break;

  case 110:
/* Line 1787 of yacc.c  */
#line 1332 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_if, &(yylsp[(1) - (4)]).beg);
		     (yyval.node)->v.cond.cond = (yyvsp[(2) - (4)].node);
		     (yyval.node)->v.cond.if_true = (yyvsp[(3) - (4)].stmtlist).head;
		     (yyval.node)->v.cond.if_false = (yyvsp[(4) - (4)].node);
	     }
    break;

  case 111:
/* Line 1787 of yacc.c  */
#line 1339 "gram.y"
    {
                     (yyval.node) = (yyvsp[(2) - (2)].stmtlist).head;
             }
    break;

  case 112:
/* Line 1787 of yacc.c  */
#line 1345 "gram.y"
    {
		     struct case_stmt *defcase = NULL, *pcase, *prev;
		     
                     (yyval.node) = alloc_node(node_type_switch, &(yylsp[(1) - (5)]).beg);
		     (yyval.node)->v.switch_stmt.node = (yyvsp[(2) - (5)].node);
		     
		     /* Make sure there is only one default case and
			place it at the beginning of the list */
		     pcase = (yyvsp[(4) - (5)].case_list).head;
		     if (!pcase->valist) {
			     defcase = pcase;
			     (yyvsp[(4) - (5)].case_list).head = (yyvsp[(4) - (5)].case_list).head->next;
		     }
		     prev = pcase;
		     pcase = pcase->next;
		     while (pcase) {
			     if (!pcase->valist) {
				     if (defcase) {
					     parse_error_locus(&pcase->locus,
					      _("duplicate default statement"));
					     parse_error_locus(&defcase->locus,
					      _("previously defined here"));
					     YYERROR;
				     }
				     defcase = pcase;
				     prev->next = pcase->next;
			     } else
				     prev = pcase;
			     pcase = pcase->next;
		     }

		     if (!defcase) {
			     defcase = xmalloc(sizeof *defcase);
                             defcase->locus = (yylsp[(5) - (5)]).beg;
			     defcase->valist = NULL;
			     defcase->node = alloc_node(node_type_noop,
							&defcase->locus);
		     }
		     defcase->next = (yyvsp[(4) - (5)].case_list).head;
		     (yyval.node)->v.switch_stmt.cases = defcase;
	     }
    break;

  case 113:
/* Line 1787 of yacc.c  */
#line 1389 "gram.y"
    {
                       (yyval.case_list).head = (yyval.case_list).tail = (yyvsp[(1) - (1)].case_stmt);
               }
    break;

  case 114:
/* Line 1787 of yacc.c  */
#line 1393 "gram.y"
    {
                       (yyval.case_list).tail->next = (yyvsp[(2) - (2)].case_stmt);
                       (yyval.case_list).tail = (yyvsp[(2) - (2)].case_stmt);
               }
    break;

  case 115:
/* Line 1787 of yacc.c  */
#line 1400 "gram.y"
    {
		     (yyval.case_stmt) = xmalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
                     (yyval.case_stmt)->locus = (yylsp[(1) - (4)]).beg;
		     (yyval.case_stmt)->valist = (yyvsp[(2) - (4)].valist_list).head;
		     (yyval.case_stmt)->node = (yyvsp[(4) - (4)].stmtlist).head;
	     }
    break;

  case 116:
/* Line 1787 of yacc.c  */
#line 1408 "gram.y"
    {
		     (yyval.case_stmt) = xmalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
                     (yyval.case_stmt)->locus = (yylsp[(1) - (3)]).beg;
		     (yyval.case_stmt)->valist = NULL;
		     (yyval.case_stmt)->node = (yyvsp[(3) - (3)].stmtlist).head;
	     }
    break;

  case 117:
/* Line 1787 of yacc.c  */
#line 1418 "gram.y"
    {
                     (yyval.valist_list).head = (yyval.valist_list).tail = xmalloc(sizeof((yyval.valist_list).head[0]));
                     (yyval.valist_list).head->next = NULL;
                     (yyval.valist_list).head->value = (yyvsp[(1) - (1)].value);
             }
    break;

  case 118:
/* Line 1787 of yacc.c  */
#line 1424 "gram.y"
    {
                     struct valist *p = xmalloc(sizeof(*p));
                     p->value = (yyvsp[(3) - (3)].value);
                     p->next = NULL;
                     (yyvsp[(1) - (3)].valist_list).tail->next = p;
                     (yyvsp[(1) - (3)].valist_list).tail = p;
                     (yyval.valist_list) = (yyvsp[(1) - (3)].valist_list);
             }
    break;

  case 119:
/* Line 1787 of yacc.c  */
#line 1435 "gram.y"
    {
		     (yyval.value).type = dtype_string;
		     (yyval.value).v.literal = (yyvsp[(1) - (1)].literal);
	     }
    break;

  case 120:
/* Line 1787 of yacc.c  */
#line 1440 "gram.y"
    {
                     (yyval.value).type = dtype_number;
                     (yyval.value).v.number = (yyvsp[(1) - (1)].number);
             }
    break;

  case 121:
/* Line 1787 of yacc.c  */
#line 1447 "gram.y"
    {
		     if ((yyvsp[(1) - (1)].value).type != dtype_string) {
                             parse_error_locus(&(yylsp[(1) - (1)]).beg,
                                         _("expected string, but found %s"),
					 type_to_string((yyvsp[(1) - (1)].value).type));
			     /* Make sure we return something usable: */
			     (yyval.literal) = string_alloc("ERROR", 5);
		     } else
			     (yyval.literal) = (yyvsp[(1) - (1)].value).v.literal; 
	     }
    break;

  case 122:
/* Line 1787 of yacc.c  */
#line 1460 "gram.y"
    {
		     (yyval.matchtype).qualifier = 0;
	     }
    break;

  case 123:
/* Line 1787 of yacc.c  */
#line 1464 "gram.y"
    {
		     (yyval.matchtype).qualifier = QUALIFIER_MX;
	     }
    break;

  case 124:
/* Line 1787 of yacc.c  */
#line 1470 "gram.y"
    {
		     (yyval.matchtype).qualifier = 0;
	     }
    break;

  case 125:
/* Line 1787 of yacc.c  */
#line 1474 "gram.y"
    {
		     (yyval.matchtype).qualifier = QUALIFIER_MX;
	     }
    break;

  case 126:
/* Line 1787 of yacc.c  */
#line 1483 "gram.y"
    {
		     leave_loop();
		     (yyvsp[(3) - (7)].loop).end_while = (yyvsp[(7) - (7)].node);
                     (yyval.node) = alloc_node(node_type_loop, &(yylsp[(1) - (7)]).beg);
		     (yyvsp[(3) - (7)].loop).body = (yyvsp[(5) - (7)].stmtlist).head;
		     (yyvsp[(3) - (7)].loop).ident = (yyvsp[(2) - (7)].literal);
		     (yyval.node)->v.loop = (yyvsp[(3) - (7)].loop);
	     }
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 1494 "gram.y"
    {
                     enter_loop((yyvsp[(1) - (1)].literal), NULL, NULL);
             }
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 1500 "gram.y"
    {
		     (yyval.literal) = NULL;
	     }
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 1507 "gram.y"
    {
                     memset(&(yyval.loop), 0, sizeof (yyval.loop));
             }
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 1514 "gram.y"
    {
                     memset(&(yyval.loop), 0, sizeof (yyval.loop));
                     switch ((yyvsp[(1) - (1)].pollarg).kw) {
                     case 0:
                             (yyval.loop).stmt = (yyvsp[(1) - (1)].pollarg).expr;
                             break;

                     case T_FOR:
                             (yyval.loop).for_stmt = (yyvsp[(1) - (1)].pollarg).expr;
                             break;

                     case T_WHILE:
                             (yyval.loop).beg_while = (yyvsp[(1) - (1)].pollarg).expr;
                             break;

                     default:
                             abort();
                     }
             }
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 1534 "gram.y"
    {
		     switch ((yyvsp[(3) - (3)].pollarg).kw) {
		     case 0:
			     if ((yyval.loop).stmt) 
                                     parse_error_locus(&(yylsp[(3) - (3)]).beg,
                                                _("duplicate loop increment"));
			     (yyval.loop).stmt = (yyvsp[(3) - (3)].pollarg).expr;
			     break;

		     case T_FOR:
			     if ((yyval.loop).for_stmt) 
                                     parse_error_locus(&(yylsp[(3) - (3)]).beg,
                                                _("duplicate for statement"));
			     (yyval.loop).for_stmt = (yyvsp[(3) - (3)].pollarg).expr;
			     break;

		     case T_WHILE:
			     if ((yyval.loop).beg_while) 
                                     parse_error_locus(&(yylsp[(3) - (3)]).beg,
                                              _("duplicate while statement"));
			     (yyval.loop).beg_while = (yyvsp[(3) - (3)].pollarg).expr;
			     break;

		     default:
			     abort();
		     }
	     }
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 1564 "gram.y"
    {
                     (yyval.pollarg).kw = 0;
                     (yyval.pollarg).expr = (yyvsp[(1) - (1)].stmtlist).head;
             }
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 1569 "gram.y"
    {
                     (yyval.pollarg).kw = T_FOR;
                     (yyval.pollarg).expr = (yyvsp[(2) - (2)].stmtlist).head;
             }
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 1574 "gram.y"
    {
                     (yyval.pollarg).kw = T_WHILE;
                     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
             }
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 1581 "gram.y"
    {
                     (yyval.node) = NULL;
             }
    break;

  case 138:
/* Line 1787 of yacc.c  */
#line 1585 "gram.y"
    {
                     (yyval.node) = (yyvsp[(2) - (2)].node);
             }
    break;

  case 139:
/* Line 1787 of yacc.c  */
#line 1591 "gram.y"
    {
		     if (!within_loop((yyvsp[(2) - (2)].literal))) {
			     if ((yyvsp[(2) - (2)].literal))
                                     parse_error_locus(&(yylsp[(2) - (2)]).beg,
                                                       _("no such loop: %s"), 
				                 (yyvsp[(2) - (2)].literal)->text);
                             parse_error_locus(&(yylsp[(1) - (2)]).beg,
                                        _("`break' used outside of `loop'"));
			     YYERROR;
		     }
                     (yyval.node) = alloc_node(node_type_break, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.literal = (yyvsp[(2) - (2)].literal);
	     }
    break;

  case 140:
/* Line 1787 of yacc.c  */
#line 1605 "gram.y"
    {
		     if (!within_loop((yyvsp[(2) - (2)].literal))) {
			     if ((yyvsp[(2) - (2)].literal)) {
                                     parse_error_locus(&(yylsp[(2) - (2)]).beg,
                                                       _("no such loop: %s"),
                                                       (yyvsp[(2) - (2)].literal)->text);
                                     parse_error_locus(&(yylsp[(1) - (2)]).beg,
                                                       _("`next' used outside `loop'"));
				     YYERROR;
			     } else {
                                     parse_error_locus(&(yylsp[(1) - (2)]).beg,
                                           _("`next' is used outside `loop'; "
                                             "did you mean `pass'?"));
				     YYERROR;
			     }
		     } else {
                             (yyval.node) = alloc_node(node_type_next, &(yylsp[(1) - (2)]).beg);
			     (yyval.node)->v.literal = (yyvsp[(2) - (2)].literal);
		     }
	     }
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 1630 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_un, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.un.opcode = unary_not;
		     (yyval.node)->v.un.arg = cast_to(dtype_number, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 142:
/* Line 1787 of yacc.c  */
#line 1636 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_eq;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 1643 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_ne;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 144:
/* Line 1787 of yacc.c  */
#line 1650 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_lt;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 145:
/* Line 1787 of yacc.c  */
#line 1657 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_le;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 146:
/* Line 1787 of yacc.c  */
#line 1664 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_gt;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 1671 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_ge;
		     (yyval.node)->v.bin.arg[0] = (yyvsp[(1) - (3)].node);
		     (yyval.node)->v.bin.arg[1] = cast_to(node_type((yyvsp[(1) - (3)].node)), (yyvsp[(3) - (3)].node));
	     }
    break;

  case 148:
/* Line 1787 of yacc.c  */
#line 1678 "gram.y"
    {
		     NODE *p;
		     
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_match;
		     (yyval.node)->v.bin.qualifier = (yyvsp[(2) - (3)].matchtype).qualifier;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_string, (yyvsp[(1) - (3)].node));
                     (yyval.node)->v.bin.arg[1] = p = alloc_node(node_type_regcomp,
                                                       &(yylsp[(2) - (3)]).beg);
		     p->v.regcomp_data.expr = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
		     p->v.regcomp_data.flags = regex_flags;
		     p->v.regcomp_data.regind = -1;
	     }
    break;

  case 149:
/* Line 1787 of yacc.c  */
#line 1692 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_fnmatch;
		     (yyval.node)->v.bin.qualifier = (yyvsp[(2) - (3)].matchtype).qualifier;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_string, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 1700 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_or;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 1707 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_and;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 153:
/* Line 1787 of yacc.c  */
#line 1717 "gram.y"
    {
                     (yyval.node) = NULL;
             }
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 1725 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_add;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 157:
/* Line 1787 of yacc.c  */
#line 1732 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_concat, &(yylsp[(2) - (3)]).beg);
		     (yyval.node)->v.concat.arg[0] = cast_to(dtype_string, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.concat.arg[1] = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 158:
/* Line 1787 of yacc.c  */
#line 1738 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_sub;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 159:
/* Line 1787 of yacc.c  */
#line 1745 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_mul;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 1752 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_div;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 161:
/* Line 1787 of yacc.c  */
#line 1759 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_mod;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 162:
/* Line 1787 of yacc.c  */
#line 1766 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_logand;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 163:
/* Line 1787 of yacc.c  */
#line 1773 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_logor;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 164:
/* Line 1787 of yacc.c  */
#line 1780 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_logxor;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 165:
/* Line 1787 of yacc.c  */
#line 1787 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_shl;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 166:
/* Line 1787 of yacc.c  */
#line 1794 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_bin, &(yylsp[(1) - (3)]).beg);
		     (yyval.node)->v.bin.opcode = bin_shr;
		     (yyval.node)->v.bin.arg[0] = cast_to(dtype_number, (yyvsp[(1) - (3)].node));
		     (yyval.node)->v.bin.arg[1] = cast_to(dtype_number, (yyvsp[(3) - (3)].node));
	     }
    break;

  case 167:
/* Line 1787 of yacc.c  */
#line 1803 "gram.y"
    {
		     if (node_type((yyvsp[(1) - (1)].node)) == dtype_unspecified)
			     parse_error(_("unspecified value not ignored as it should be"));
	     }
    break;

  case 168:
/* Line 1787 of yacc.c  */
#line 1808 "gram.y"
    {
                     (yyval.node) = (yyvsp[(2) - (3)].node);
             }
    break;

  case 169:
/* Line 1787 of yacc.c  */
#line 1812 "gram.y"
    {
                     (yyval.node) = cast_to((yyvsp[(1) - (4)].type), (yyvsp[(3) - (4)].node));
             }
    break;

  case 171:
/* Line 1787 of yacc.c  */
#line 1817 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_un, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.un.opcode = unary_minus;
		     (yyval.node)->v.un.arg = cast_to(dtype_number, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 172:
/* Line 1787 of yacc.c  */
#line 1823 "gram.y"
    {
                     (yyval.node) = (yyvsp[(2) - (2)].node);
             }
    break;

  case 173:
/* Line 1787 of yacc.c  */
#line 1827 "gram.y"
    {
                     (yyval.node) = alloc_node(node_type_un, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.un.opcode = unary_lognot;
		     (yyval.node)->v.un.arg = cast_to(dtype_number, (yyvsp[(2) - (2)].node));
	     }
    break;

  case 174:
/* Line 1787 of yacc.c  */
#line 1835 "gram.y"
    {
		     (yyval.node) = create_node_symbol((yyvsp[(1) - (1)].literal), &(yylsp[(1) - (1)]).beg);
	     }
    break;

  case 175:
/* Line 1787 of yacc.c  */
#line 1839 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_number, &(yylsp[(1) - (1)]).beg);
		     (yyval.node)->v.number = (yyvsp[(1) - (1)].number);
	     }
    break;

  case 176:
/* Line 1787 of yacc.c  */
#line 1844 "gram.y"
    {
		     (yyval.node) = create_node_backref((yyvsp[(1) - (1)].number), &(yylsp[(1) - (1)]).beg);
	     }
    break;

  case 178:
/* Line 1787 of yacc.c  */
#line 1849 "gram.y"
    {
		     (yyval.node) = create_node_argcount(&(yylsp[(1) - (1)]).beg);
	     }
    break;

  case 179:
/* Line 1787 of yacc.c  */
#line 1853 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_offset, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.var_ref.variable = (yyvsp[(2) - (2)].var);
		     (yyval.node)->v.var_ref.nframes = catch_nesting;
	     }
    break;

  case 180:
/* Line 1787 of yacc.c  */
#line 1859 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_vaptr, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.node = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1868 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_concat, &(yylsp[(2) - (2)]).beg);
		     (yyval.node)->v.concat.arg[0] = (yyvsp[(1) - (2)].node);
		     (yyval.node)->v.concat.arg[1] = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 184:
/* Line 1787 of yacc.c  */
#line 1876 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_string, &(yylsp[(1) - (1)]).beg);
		     (yyval.node)->v.literal = (yyvsp[(1) - (1)].literal);
	     }
    break;

  case 186:
/* Line 1787 of yacc.c  */
#line 1884 "gram.y"
    {
                     (yyval.node) = create_node_variable((yyvsp[(1) - (1)].var), &(yylsp[(1) - (1)]).beg);
	     }
    break;

  case 187:
/* Line 1787 of yacc.c  */
#line 1888 "gram.y"
    {
                     (yyval.node) = create_node_arg((yyvsp[(1) - (1)].number), &(yylsp[(1) - (1)]).beg);
 	     }
    break;

  case 188:
/* Line 1787 of yacc.c  */
#line 1892 "gram.y"
    {
		     if (outer_context == context_function) {
			     if (func->varargs) {
                                     (yyval.node) = alloc_node(node_type_argx, &(yylsp[(1) - (4)]).beg);
				     (yyval.node)->v.argx.nargs = PARMCOUNT() +
					     FUNC_HIDDEN_ARGS(func);
				     (yyval.node)->v.argx.node = (yyvsp[(3) - (4)].node);
			     } else {
                                     (yyval.node) = alloc_node(node_type_noop, &(yylsp[(1) - (4)]).beg);
                                     parse_error_locus(&(yylsp[(1) - (4)]).beg,
                                                 _("$(expr) is allowed only "
						   "in a function with "
						   "variable number of "
						   "arguments"));
			     }
		     } else {
                             (yyval.node) = alloc_node(node_type_noop, &(yylsp[(1) - (4)]).beg);
                             parse_error_locus(&(yylsp[(1) - (4)]).beg,
                                         _("$(expr) is allowed only "
					   "in a function with "
					   "variable number of "
					   "arguments"));
		     }
	     }
    break;

  case 190:
/* Line 1787 of yacc.c  */
#line 1920 "gram.y"
    {
                     (yyval.node) = (yyvsp[(2) - (3)].node);
             }
    break;

  case 191:
/* Line 1787 of yacc.c  */
#line 1926 "gram.y"
    {
		     if (check_builtin_usage((yyvsp[(1) - (4)].builtin)))
			     YYERROR;
		     if ((yyvsp[(3) - (4)].arglist).count < (yyvsp[(1) - (4)].builtin)->parmcount - (yyvsp[(1) - (4)].builtin)->optcount) {
                             parse_error_locus(&(yylsp[(1) - (4)]).beg,
                                       _("too few arguments in call to `%s'"),
					 (yyvsp[(1) - (4)].builtin)->name);
			     YYERROR;
		     } else if ((yyvsp[(3) - (4)].arglist).count > (yyvsp[(1) - (4)].builtin)->parmcount
				&& !((yyvsp[(1) - (4)].builtin)->flags & MFD_BUILTIN_VARIADIC)) {
                             parse_error_locus(&(yylsp[(1) - (4)]).beg,
                                      _("too many arguments in call to `%s'"),
					 (yyvsp[(1) - (4)].builtin)->name);
			     YYERROR;
		     } else {
                             (yyval.node) = alloc_node(node_type_builtin, &(yylsp[(1) - (4)]).beg);
			     (yyval.node)->v.builtin.builtin = (yyvsp[(1) - (4)].builtin);
			     (yyval.node)->v.builtin.args =
					     reverse(cast_arg_list((yyvsp[(3) - (4)].arglist).head,
 							       (yyvsp[(1) - (4)].builtin)->parmcount,
							       (yyvsp[(1) - (4)].builtin)->parmtype,
							       (yyval.node)->v.builtin.builtin->flags & MFD_BUILTIN_NO_PROMOTE));
		     }
	     }
    break;

  case 192:
/* Line 1787 of yacc.c  */
#line 1951 "gram.y"
    {
		     if (check_builtin_usage((yyvsp[(1) - (3)].builtin)))
			     YYERROR;
		     if ((yyvsp[(1) - (3)].builtin)->parmcount - (yyvsp[(1) - (3)].builtin)->optcount) {
                             parse_error_locus(&(yylsp[(1) - (3)]).beg,
                                       _("too few arguments in call to `%s'"),
					 (yyvsp[(1) - (3)].builtin)->name);
			     YYERROR;
		     } else {
                             (yyval.node) = alloc_node(node_type_builtin, &(yylsp[(1) - (3)]).beg);
			     (yyval.node)->v.builtin.builtin = (yyvsp[(1) - (3)].builtin);
			     (yyval.node)->v.builtin.args = NULL;
		     }
	     }
    break;

  case 193:
/* Line 1787 of yacc.c  */
#line 1966 "gram.y"
    {
                     if (check_func_usage((yyvsp[(1) - (4)].function), &(yylsp[(1) - (4)]).beg))
			     YYERROR;
		     (yyval.node) = function_call((yyvsp[(1) - (4)].function), (yyvsp[(3) - (4)].arglist).count, (yyvsp[(3) - (4)].arglist).head);
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 194:
/* Line 1787 of yacc.c  */
#line 1974 "gram.y"
    {
                     if (check_func_usage((yyvsp[(1) - (3)].function), &(yylsp[(1) - (3)]).beg))
			     YYERROR;
		     (yyval.node) = function_call((yyvsp[(1) - (3)].function), 0, NULL);
		     if (!(yyval.node))
			     YYERROR;
	     }
    break;

  case 195:
/* Line 1787 of yacc.c  */
#line 1984 "gram.y"
    {
                     (yyvsp[(1) - (1)].node)->next = NULL;
                     (yyval.arglist).head = (yyval.arglist).tail = (yyvsp[(1) - (1)].node);
                     (yyval.arglist).count = 1;
             }
    break;

  case 196:
/* Line 1787 of yacc.c  */
#line 1990 "gram.y"
    {
                     (yyvsp[(1) - (3)].arglist).tail->next = (yyvsp[(3) - (3)].node);
                     (yyvsp[(1) - (3)].arglist).tail = (yyvsp[(3) - (3)].node);
                     (yyvsp[(1) - (3)].arglist).count++;
                     (yyval.arglist) = (yyvsp[(1) - (3)].arglist);
             }
    break;

  case 197:
/* Line 1787 of yacc.c  */
#line 1999 "gram.y"
    {
		     add_xref((yyvsp[(1) - (1)].var), &(yylsp[(1) - (1)]).beg);
	     }
    break;

  case 198:
/* Line 1787 of yacc.c  */
#line 2003 "gram.y"
    {
                     YYERROR;
             }
    break;

  case 199:
/* Line 1787 of yacc.c  */
#line 2009 "gram.y"
    {
		     if (outer_context == context_function) {
			     func->exmask->all |= (yyval.node)->v.catch.exmask->all;
			     bitmask_merge(&func->exmask->bm,
					   &(yyval.node)->v.catch.exmask->bm);
		     }
	     }
    break;

  case 200:
/* Line 1787 of yacc.c  */
#line 2017 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_try, &(yylsp[(1) - (2)]).beg);
		     (yyval.node)->v.try.node = (yyvsp[(1) - (2)].node);
		     (yyval.node)->v.try.catch = (yyvsp[(2) - (2)].node);
	     }
    break;

  case 201:
/* Line 1787 of yacc.c  */
#line 2025 "gram.y"
    {
		     (yyval.node) = (yyvsp[(3) - (4)].stmtlist).head;
	     }
    break;

  case 202:
/* Line 1787 of yacc.c  */
#line 2032 "gram.y"
    { (yyval.tie_in) = inner_context;
                   inner_context = context_catch; 
                   catch_nesting++; }
    break;

  case 203:
/* Line 1787 of yacc.c  */
#line 2036 "gram.y"
    {
		      int i;
		      struct valist *p;

		      inner_context = (yyvsp[(4) - (6)].tie_in);
		      catch_nesting--;
                      (yyval.node) = alloc_node(node_type_catch, &(yylsp[(1) - (6)]).beg);
		      (yyval.node)->v.catch.exmask = exmask_create();
		      (yyval.node)->v.catch.context = outer_context;/*??*/
		      (yyval.node)->v.catch.exmask->all = (yyvsp[(2) - (6)].catchlist).all;
		      if (!(yyvsp[(2) - (6)].catchlist).all) {
			      for (i = 0, p = (yyvsp[(2) - (6)].catchlist).valist; p; p = p->next, i++) {
				      if (p->value.type != dtype_number) {
					      parse_error_locus(&(yylsp[(1) - (6)]).beg,
								_("expected numeric value, but found `%s'"),
								p->value.v.literal->text);
					      continue;
				      }
				      bitmask_set(&(yyval.node)->v.catch.exmask->bm,
						  p->value.v.number);
			      }
		      }
		      (yyval.node)->v.catch.node = (yyvsp[(5) - (6)].stmtlist).head;
	      }
    break;

  case 204:
/* Line 1787 of yacc.c  */
#line 2063 "gram.y"
    {
		      (yyval.catchlist).all = 1;
	      }
    break;

  case 205:
/* Line 1787 of yacc.c  */
#line 2067 "gram.y"
    {
		      (yyval.catchlist).all = 0;
		      (yyval.catchlist).valist = (yyvsp[(1) - (1)].valist_list).head;
	      }
    break;

  case 206:
/* Line 1787 of yacc.c  */
#line 2074 "gram.y"
    {
                      (yyval.node) = alloc_node(node_type_throw, &(yylsp[(1) - (3)]).beg);
		      if ((yyvsp[(2) - (3)].value).type != dtype_number) 
                              parse_error_locus(&(yylsp[(2) - (3)]).beg,
                                           _("exception code not a number"));
		      else if ((yyvsp[(2) - (3)].value).v.number > exception_count)
                              parse_error_locus(&(yylsp[(2) - (3)]).beg,
                                           _("invalid exception number: %lu"),
					  (yyvsp[(2) - (3)].value).v.number);

		      (yyval.node)->v.throw.code = (yyvsp[(2) - (3)].value).v.number;
		      (yyval.node)->v.throw.expr = cast_to(dtype_string, (yyvsp[(3) - (3)].node));
	      }
    break;

  case 207:
/* Line 1787 of yacc.c  */
#line 2090 "gram.y"
    {
		      if (!func) 
			      parse_error_locus(&(yylsp[(1) - (1)]).beg,
				      _("`return' outside of a function"));
		      else if (func->rettype != dtype_unspecified) 
			      parse_error_locus(&(yylsp[(1) - (1)]).beg,
				      _("`return' with no value, in function "
				      "returning non-void"));
		      (yyval.node) = alloc_node(node_type_return, &(yylsp[(1) - (1)]).beg);
		      (yyval.node)->v.node = NULL;
	      }
    break;

  case 208:
/* Line 1787 of yacc.c  */
#line 2102 "gram.y"
    {
		      if (!func) 
			      parse_error_locus(&(yylsp[(1) - (2)]).beg,
					_("`return' outside of a function"));
		      else {
			      (yyval.node) = alloc_node(node_type_return, &(yylsp[(1) - (2)]).beg);
			      if (func->rettype == dtype_unspecified) { 
				      parse_error_locus(&(yylsp[(1) - (2)]).beg,
				       _("`return' with a value, in function "
				       "returning void"));
				      (yyval.node)->v.node = NULL;
			      }
			      else
				      (yyval.node)->v.node = cast_to(func->rettype, (yyvsp[(2) - (2)].node));
		      }
	      }
    break;

  case 209:
/* Line 1787 of yacc.c  */
#line 2125 "gram.y"
    {
		     NODE *sel, *np;
		     NODE *head = NULL, *tail;
		     struct function *fp;
		     
		     fp = function_lookup((yyvsp[(2) - (5)].poll).client_addr ?
					  "strictpoll" : "stdpoll");
		     if (!fp) {
			     parse_error_locus(&(yylsp[(1) - (5)]).beg,
					       _("`on poll' used without prior `require poll'"));
			     YYERROR;
		     }

		     /* Build argument list */
		     if ((yyvsp[(2) - (5)].poll).client_addr) {
			     head = tail = (yyvsp[(2) - (5)].poll).client_addr;
			     tail = (yyvsp[(2) - (5)].poll).email;
			     if (!tail) {
                                     parse_error_locus(&(yylsp[(2) - (5)]).beg,
                                          _("recipient address not specified "
                                            "in `on poll' construct"));
				     YYERROR;
			     }
			     tail->next = NULL;
			     head->next = tail;
		     } else
			     head = tail = (yyvsp[(2) - (5)].poll).email;

		     if ((yyvsp[(2) - (5)].poll).ehlo)
			     np = (yyvsp[(2) - (5)].poll).ehlo;
		     else {
			     /* FIXME: Pass NULL? */
                             np = alloc_node(node_type_variable, &(yylsp[(2) - (5)]).beg);
			     np->v.var_ref.variable =
				     variable_lookup("ehlo_domain");
			     np->v.var_ref.nframes = 0;
		     }
		     tail->next = np;
		     tail = np;

		     if ((yyvsp[(2) - (5)].poll).mailfrom)
			     np = (yyvsp[(2) - (5)].poll).mailfrom;
		     else {
			     /* FIXME: Pass NULL? */
                             np = alloc_node(node_type_variable, &(yylsp[(2) - (5)]).beg);
			     np->v.var_ref.variable =
				     variable_lookup("mailfrom_address");
			     np->v.var_ref.nframes = 0;
		     }
		     tail->next = np;
		     tail = np;

		     sel = function_call(fp, nodelistlength(head), head);

		     (yyval.node) = alloc_node(node_type_switch, &(yylsp[(1) - (5)]).beg);
		     (yyval.node)->v.switch_stmt.node = sel;
		     (yyval.node)->v.switch_stmt.cases = (yyvsp[(4) - (5)].case_list).head;
	     }
    break;

  case 210:
/* Line 1787 of yacc.c  */
#line 2184 "gram.y"
    {
		     (yyval.node) = alloc_node(node_type_switch, &(yylsp[(1) - (5)]).beg);
		     (yyval.node)->v.switch_stmt.node = (yyvsp[(2) - (5)].node);
		     (yyval.node)->v.switch_stmt.cases = (yyvsp[(4) - (5)].case_list).head;
             }
    break;

  case 211:
/* Line 1787 of yacc.c  */
#line 2192 "gram.y"
    {
                     tie_in_onblock(1);
             }
    break;

  case 212:
/* Line 1787 of yacc.c  */
#line 2198 "gram.y"
    {
                     tie_in_onblock(0);
             }
    break;

  case 213:
/* Line 1787 of yacc.c  */
#line 2204 "gram.y"
    {
                     struct pollarg arg;
                     
                     arg.kw = T_FOR;
                     arg.expr = (yyvsp[(2) - (2)].node);
                     memset(&(yyval.poll), 0, sizeof (yyval.poll));
                     set_poll_arg(&(yyval.poll), arg.kw, arg.expr);
             }
    break;

  case 214:
/* Line 1787 of yacc.c  */
#line 2213 "gram.y"
    {
                     struct pollarg arg;
                     
                     arg.kw = T_FOR;
                     arg.expr = (yyvsp[(2) - (3)].node);
                     set_poll_arg(&(yyvsp[(3) - (3)].poll), arg.kw, arg.expr);
                     (yyval.poll) = (yyvsp[(3) - (3)].poll);
             }
    break;

  case 215:
/* Line 1787 of yacc.c  */
#line 2222 "gram.y"
    {
                     (yyval.poll) = (yyvsp[(2) - (2)].poll);
             }
    break;

  case 216:
/* Line 1787 of yacc.c  */
#line 2228 "gram.y"
    {
                     memset(&(yyval.poll), 0, sizeof (yyval.poll));
                     set_poll_arg(&(yyval.poll), (yyvsp[(1) - (1)].pollarg).kw, (yyvsp[(1) - (1)].pollarg).expr);
             }
    break;

  case 217:
/* Line 1787 of yacc.c  */
#line 2233 "gram.y"
    {
                     set_poll_arg(&(yyvsp[(1) - (2)].poll), (yyvsp[(2) - (2)].pollarg).kw, (yyvsp[(2) - (2)].pollarg).expr);
                     (yyval.poll) = (yyvsp[(1) - (2)].poll);
             }
    break;

  case 218:
/* Line 1787 of yacc.c  */
#line 2240 "gram.y"
    {
                     (yyval.pollarg).kw = T_FOR;
                     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
             }
    break;

  case 219:
/* Line 1787 of yacc.c  */
#line 2245 "gram.y"
    {
                     (yyval.pollarg).kw = T_HOST;
                     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
             }
    break;

  case 220:
/* Line 1787 of yacc.c  */
#line 2250 "gram.y"
    {
                     (yyval.pollarg).kw = T_AS;
                     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
             }
    break;

  case 221:
/* Line 1787 of yacc.c  */
#line 2255 "gram.y"
    {
                     (yyval.pollarg).kw = T_FROM;
                     (yyval.pollarg).expr = (yyvsp[(2) - (2)].node);
             }
    break;

  case 222:
/* Line 1787 of yacc.c  */
#line 2263 "gram.y"
    {
                     (yyval.case_list).head = (yyval.case_list).tail = (yyvsp[(1) - (1)].case_stmt);
             }
    break;

  case 223:
/* Line 1787 of yacc.c  */
#line 2267 "gram.y"
    {
                     (yyvsp[(1) - (2)].case_list).tail->next = (yyvsp[(2) - (2)].case_stmt);
                     (yyvsp[(1) - (2)].case_list).tail = (yyvsp[(2) - (2)].case_stmt);
                     (yyval.case_list) = (yyvsp[(1) - (2)].case_list);
             }
    break;

  case 224:
/* Line 1787 of yacc.c  */
#line 2275 "gram.y"
    {
		     struct valist *p;

		     for (p = (yyvsp[(2) - (4)].valist_list).head; p; p = p->next) {
			     if (p->value.type == dtype_string) {
                                     parse_error_locus(&(yylsp[(2) - (4)]).beg,
                                                       _("invalid data type, "
                                                         "expected number"));
				     /* Try to continue */
				     p->value.type = dtype_number;
				     p->value.v.number = 0;
			     }
		     }
		     
		     (yyval.case_stmt) = xmalloc(sizeof *(yyval.case_stmt));
		     (yyval.case_stmt)->next = NULL;
                     (yyval.case_stmt)->locus = (yylsp[(1) - (4)]).beg;
		     (yyval.case_stmt)->valist = (yyvsp[(2) - (4)].valist_list).head;
		     (yyval.case_stmt)->node = (yyvsp[(4) - (4)].stmtlist).head;
	     }
    break;


/* Line 1787 of yacc.c  */
#line 4940 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 2297 "gram.y"


int
yyerror(char *s)
{
        parse_error("%s", s);
        return 0;
}

int
parse_program(char *name, int ydebug)
{
        int rc;
        yydebug = ydebug;
        if (lex_new_source(name, 0))
                return -1;
        outer_context = inner_context = context_none;
        catch_nesting = 0;
        code_immediate(NULL); /* Reserve 0 slot */
        rc = yyparse() + error_count;
        final_deprecation_warning();
        return rc;
}

NODE *
alloc_node(enum node_type type, const struct locus *locus)
{
        NODE *node = malloc(sizeof(*node));
        if (!node) {
                yyerror("Not enough memory");
                abort();
        }
        node->type = type;
        node->locus = *locus;
        node->next = NULL;
        return node;
}

void
free_node(NODE *node)
{
        free(node);
}

void
copy_node(NODE *dest, NODE *src)
{
        dest->type = src->type;
        dest->locus = src->locus;
        dest->v = src->v;
}

void
free_subtree(NODE *node)
{
        /*FIXME*/
}

void
free_parser_data()
{
	/*FIXME*/
}


/* Print parse tree */

static void print_node_list(NODE *node, int indent);
static void print_node_list_reverse(NODE *node, int level);
static void print_node(NODE *node, int indent);
void print_stat(sfsistat stat);
static int dbg_setreply(void *data, char *code, char *xcode, char *message);
static void dbg_msgmod(void *data, struct msgmod_closure *clos);

static void
print_level(int level)
{
        level *= 2;
        printf("%*.*s", level, level, "");
}

static void
print_bin_op(enum bin_opcode opcode)
{
        char *p;
        switch (opcode) {
        case bin_and:
                p = "AND";
                break;
                
        case bin_or:
                p = "OR";
                break;
                
        case bin_eq:
                p = "EQ";
                break;
                
        case bin_ne:
                p = "NE";
                break;
                
        case bin_lt:
                p = "LT";
                break;
                
        case bin_le:
                p = "LE";
                break;
                
        case bin_gt:
                p = "GT";
                break;
                
        case bin_ge:
                p = "GE";
                break;
                
        case bin_match:
                p = "MATCH";
                break;
                
        case bin_fnmatch:
                p = "FNMATCH";
                break;

        case bin_add:
                p = "ADD";
                break;
                
        case bin_sub:
                p = "SUB";
                break;
                
        case bin_mul:
                p = "MUL";
                break;
                
        case bin_div:
                p = "DIV";
                break;

        case bin_mod:
                p = "MOD";
                break;

        case bin_logand:
                p = "LOGAND";
                break;
                
        case bin_logor:
                p = "LOGOR";
                break;
                
        case bin_logxor:
                p = "LOGXOR";
                break;

	case bin_shl:
		p = "SHL";
		break;

	case bin_shr:
		p = "SHR";
		break;
		
        default:
                p = "UNKNOWN_OP";
        }
        printf("%s", p);
}

static void
print_quoted_string(const char *str)
{
        for (; *str; str++) {
                if (c_isprint(*str))
                        putchar(*str);
                else {
                        putchar('\\');
                        switch (*str) {
                        case '\a':
                                putchar('a');
                                break;
                        case '\b':
                                putchar('b');
                                break;
                        case '\f':
                                putchar('f');
                                break;
                        case '\n':
                                putchar('n');
                                break;
                        case '\r':
                                putchar('r');
                                break;
                        case '\t':
                                putchar('t');
                                break;
                        default:
                                printf("%03o", *str);
                        }
                }
        }
}

struct node_drv {
        void (*print) (NODE *, int);
        void (*mark) (NODE *);
        void (*code) (NODE *, struct locus **);
        void (*optimize) (NODE *);
};

static void traverse_tree(NODE *node);
static void code_node(NODE *node);
static void code_node(NODE *node);
static void optimize_node(NODE *node);
static void optimize(NODE *node);
static void record_switch(struct switch_stmt *sw);

#include "drivers.c"
#include "node-tab.c"

struct node_drv *
find_node_drv(enum node_type type)
{
        if (type >= NELEMS(nodetab)) {
                parse_error(_("INTERNAL ERROR at %s:%d, "
                              "unexpected node type %d"),
                            __FILE__, __LINE__,
                            type);
                abort();
        }
        return nodetab + type;
}

static void
print_node(NODE *node, int level)
{
        struct node_drv *nd = find_node_drv(node->type);
        if (nd->print)
                nd->print(node, level);
}       

static void
print_node_list(NODE *node, int level)
{
        for (; node; node = node->next)
                print_node(node, level);
}

static void
print_node_list_reverse(NODE *node, int level)
{
        if (node) {
                print_node_list_reverse(node->next, level);
                print_node(node, level);
        }
}

int
function_enumerator(void *sym, void *data)
{
        int i;
        struct function *fsym = sym;
        struct function *f =
                (struct function *)symbol_resolve_alias(&fsym->sym);
        struct module *mod = data;

        if (f->sym.module != mod)
                return 0;
        printf("function %s (", f->sym.name);
        for (i = 0; i < f->parmcount; i++) {
                printf("%s", type_to_string(f->parmtype[i]));
                if (i < f->parmcount-1)
                        putchar(',');
        }
        putchar(')');
        if (f->rettype != dtype_unspecified)
                printf(" returns %s", type_to_string(f->rettype));
        printf(":\n");
        print_node_list(f->node, 0);
        printf("END function %s\n", f->sym.name);
        return 0;
}
                
void
print_syntax_tree()
{
        struct module **modv;
        size_t i, modc;

        enum smtp_state tag;

        printf("State handlers:\n");
        printf("---------------\n");
        for (tag = smtp_state_first; tag < smtp_state_count; tag++) {
                if (root_node[tag]) {
                        printf("%s:\n", state_to_string(tag));
                        print_node_list(root_node[tag], 0);
                        putchar('\n');
                }
        }
        printf("User functions:\n");
        printf("---------------\n");
        
        collect_modules(&modv, &modc);
        for (i = 0; i < modc; i++) {
                size_t n;

                n = printf("Module %s (%s)\n", modv[i]->name,
                           modv[i]->file);
                while (n--)
                        putchar('-');
                putchar('\n');
                symtab_enumerate(MODULE_SYMTAB(modv[i], namespace_function),
                                 function_enumerator, modv[i]);
                putchar('\n');
        }
        free(modv);
}


/* Cross-reference support */

struct collect_data {
        struct obstack stk;
        size_t count;
};

static int
variable_enumerator(void *item, void *data)
{
        struct variable *var = item;
        struct collect_data *p = data;
        if (var->sym.flags & (SYM_VOLATILE | SYM_REFERENCED)) {
                obstack_grow(&p->stk, &var, sizeof var);
                p->count++;
        }
        return 0;
}

int
print_locus(void *item, void *data)
{
        struct locus *loc = item;
        struct locus **prev = data;
        int c;

        if (!*prev) {
                *prev = loc;
                printf("%s", loc->file);
                c = ':';
        } else if (strcmp((*prev)->file, loc->file)) {
                *prev = loc;
                printf(", %s", loc->file);
                c = ':';
        } else
                c = ',';
        printf("%c%lu", c, (unsigned long) loc->line);
        return 0;
}

void
print_xref_var(struct variable *var)
{
        struct locus *prev = NULL;
        var = (struct variable *)symbol_resolve_alias(&var->sym);
        printf("%-32.32s %6s %lu ",
               var->sym.name, type_to_string(var->type),
               (unsigned long)var->off);
        mu_list_foreach(var->xref, print_locus, &prev);
        printf("\n");
}

int
vp_comp(const void *a, const void *b)
{
        struct variable * const *va = a, * const *vb = b;
        return strcmp((*va)->sym.name, (*vb)->sym.name);
}

void
print_xref()
{
        struct collect_data cd;
        struct variable **vp;
        size_t i;
        
        obstack_init(&cd.stk);
        cd.count = 0;
        symtab_enumerate(TOP_MODULE_SYMTAB(namespace_variable),
                         variable_enumerator, &cd);
        printf("Cross-references:\n");
        printf("-----------------\n");
        
        vp = obstack_finish(&cd.stk);
        qsort(vp, cd.count, sizeof *vp, vp_comp);
        for (i = 0; i < cd.count; i++, vp++) 
                print_xref_var(*vp);
        obstack_free(&cd.stk, NULL);
}


static mu_list_t smtp_macro_list[gacopyz_stage_max];

static enum gacopyz_stage 
smtp_to_gacopyz_stage(enum smtp_state tag)
{
        switch (tag) {
        case smtp_state_connect:
                return gacopyz_stage_conn;
        case smtp_state_helo:
                return gacopyz_stage_helo;
        case smtp_state_envfrom:
                return gacopyz_stage_mail;
        case smtp_state_envrcpt:
                return gacopyz_stage_rcpt;
        case smtp_state_data:
        case smtp_state_header:
        case smtp_state_body:
                return gacopyz_stage_data;
        case smtp_state_eoh:
                return gacopyz_stage_eoh;
        case smtp_state_eom:
                return gacopyz_stage_eom;
        default:
                break;
        }
        return gacopyz_stage_none;
}

static int
compare_macro_names (const void *item, const void *data)
{
	const char *elt;
	size_t elen;
	const char *arg;
	size_t alen;

	elt = item;
	elen = strlen (elt);
	if (elt[0] == '{') {
		elt++;
		elen -= 2;
	}

	arg = data;
	alen = strlen (arg);
	if (arg[0] == '{') {
		arg++;
		alen -= 2;
	}

	if (alen != elen)
		return 1;
	return memcmp (elt, arg, alen);
}

void
register_macro(enum smtp_state state, const char *macro)
{
        enum gacopyz_stage ind = smtp_to_gacopyz_stage(state);
	
        if (ind == gacopyz_stage_none)
                return;
        if (!smtp_macro_list[ind]) {
                mu_list_create(&smtp_macro_list[ind]);
                mu_list_set_comparator(smtp_macro_list[ind],
				       compare_macro_names);
        }
        /* FIXME: MU: 2nd arg should be const? */
        if (mu_list_locate(smtp_macro_list[ind], (void*) macro, NULL)) {
		char *cmacro;
		if (macro[1] == 0 || macro[0] == '{')
			cmacro = xstrdup (macro);
		else {
			size_t mlen = strlen (macro);
			cmacro = xmalloc (mlen + 3);
			cmacro[0] = '{';
			memcpy (cmacro + 1, macro, mlen);
			cmacro[mlen + 1] = '}';
			cmacro[mlen + 2] = 0;
		}
                mu_list_append(smtp_macro_list[ind], cmacro);
	}
}

static int
print_macro(void *item, void *data)
{
        int *p = data;
        if (*p) {
                printf(" ");
                *p = 0;
        } else
                printf(", ");
        printf("%s", (char*) item);
        return 0;
}

void
print_used_macros()
{
        enum gacopyz_stage i;
        
        for (i = 0; i < gacopyz_stage_max; i++) {
                if (smtp_macro_list[i]) {
                        int n = 1;
                        printf("%s", gacopyz_stage_name[i]);
                        mu_list_foreach(smtp_macro_list[i], print_macro, &n);
                        printf("\n");
                }
        }
}

struct macro_acc {
        size_t size;
        char *buf;
};

static int
add_macro_size(void *item, void *data)
{
        char *macro = (char*) item;
        struct macro_acc *mp = data;
        mp->size += strlen(macro) + 1;
        return 0;
}

static int
concat_macro(void *item, void *data)
{
        char *macro = (char*) item;
        struct macro_acc *mp = data;
        size_t len = strlen(macro);
        char *pbuf = mp->buf + mp->size;
        memcpy(pbuf, macro, len);
        pbuf[len++] = ' ';
        mp->size += len;
        return 0;
}

char *
get_stage_macro_string(enum gacopyz_stage i)
{
        struct macro_acc acc;
        size_t size;
        mu_list_t list = smtp_macro_list[i];
        if (!list)
                return NULL;
                
        acc.size = 0;
        mu_list_foreach(list, add_macro_size, &acc);
        if (!acc.size)
                return NULL;
        size = acc.size;
                
        acc.size = 0;
        acc.buf = xmalloc (size);
        mu_list_foreach(list, concat_macro, &acc);
        acc.buf[size-1] = 0;
        return acc.buf;
}


/* Code generation */

static void
code_node(NODE *node)
{
        if (!node) 
                error_count++;
        else {
                static struct locus *old_locus;
                struct node_drv *nd = find_node_drv(node->type);
                if (nd->code)
                        nd->code(node, &old_locus);
        }
}

static void
traverse_tree(NODE *node)
{
        for (; node; node = node->next)
                code_node(node);
}

static void
optimize_node(NODE *node)
{
        if (!node) 
                error_count++;
        else {
                struct node_drv *nd = find_node_drv(node->type);
                if (nd->optimize)
                        nd->optimize(node);
        }
}

static void
optimize(NODE *node)
{
        for (; node; node = node->next)
                optimize_node(node);
}

static int
optimize_tree(NODE *node)
{
        if (optimization_level)
                optimize(node);
        return error_count;
}


static struct switch_stmt *switch_root;

static void
record_switch(struct switch_stmt *sw)
{
        sw->next = switch_root;
        switch_root = sw;
}


static struct exmask *exmask_root;

struct exmask *
exmask_create()
{
	struct exmask *p = xmalloc(sizeof(*p));
	p->next = exmask_root;
	p->off = 0;
	p->all = 0;
	bitmask_init(&p->bm);
	exmask_root = p;
	return p;
}



static void
mark_node(NODE *node)
{
        if (!node) 
                error_count++;
        else {
                struct node_drv *nd = find_node_drv(node->type);
                if (nd->mark)
                        nd->mark(node);
        }
}

static void
mark(NODE *node)
{
        for (; node; node = node->next)
                mark_node(node);
}
        

static int
codegen(prog_counter_t *pc, NODE *node, struct exmask *exmask,
	int finalize, size_t nautos)
{
	int save_mask;
	
	if (error_count)
		return 1;
	
	*pc = code_get_counter();
	jump_pc = 0;
	if (nautos) {
		code_op(opcode_stkalloc);
		code_immediate((void*)nautos);
	}
	save_mask = exmask && bitmask_nset(&exmask->bm);
	if (save_mask) {
		code_op(opcode_saveex);
		code_exmask(exmask);
	}
	traverse_tree(node);

	jump_fixup(jump_pc, code_get_counter());
	if (save_mask) 
		code_op(opcode_restex);
	
	if (finalize)
		code_op(opcode_nil);
	else
		code_op(opcode_return);
		
	return 0;
}

static void
compile_tree(NODE *node)
{
        struct node_drv *nd;
        struct locus *plocus;
        
        for (; node; node = node->next) {
                switch (node->type) {
                case node_type_progdecl:
                case node_type_funcdecl:
                        nd = find_node_drv(node->type);
                        if (!nd->code)
                                abort();
                        nd->code(node, &plocus);
                        break;
                        
                default:
                        parse_error_locus(&node->locus,
                                          _("INTERNAL ERROR at %s:%d, "
                                            "unexpected node type %d"),
                                          __FILE__, __LINE__,
                                          node->type);
                        break;
                }
        }
}
                



enum regex_mode { regex_enable, regex_disable, regex_set };

static mf_stack_t regex_stack;

void
regex_push()
{
        if (!regex_stack)
                regex_stack = mf_stack_create(sizeof regex_flags, 0);
        mf_stack_push(regex_stack, &regex_flags);
}

void
regex_pop()
{
        if (!regex_stack || mf_stack_pop(regex_stack, &regex_flags))
                parse_error(_("nothing to pop"));
}

static void
pragma_regex(int argc, char **argv, const char *text)
{
        enum regex_mode mode = regex_set;
        int i = 1;

        if (strcmp(argv[i], "push") == 0) {
                regex_push();
                i++;
        } else if (strcmp(argv[i], "pop") == 0) {
                regex_pop();
                i++;
        }

        for (; i < argc; i++) {
                int bit;
                char *p = argv[i];
                switch (p[0]) {
                case '+':
                        mode = regex_enable;
                        p++;
                        break;

                case '-':
                        mode = regex_disable;
                        p++;
                        break;

                case '=':
                        mode = regex_set;
                        p++;
                        break;
                }

                if (strcmp (p, REG_EXTENDED_NAME) == 0)
                        bit = REG_EXTENDED;
                else if (strcmp (p, REG_ICASE_NAME) == 0)
                        bit = REG_ICASE;
                else if (strcmp (p, REG_NEWLINE_NAME) == 0)
                        bit = REG_NEWLINE;
                else {
                        parse_error(_("unknown regexp flag: %s"), p);
                        return;
                }

                switch (mode) {
                case regex_disable:
                        regex_flags &= ~bit;
                        break;
                case regex_enable:
                        regex_flags |= bit;
                        break;
                case regex_set:
                        regex_flags = bit;
                        break;
                }
        }
}       

static int
strtosize(const char *text, size_t *psize)
{
        unsigned long n;
        size_t size;
        char *p;

        n = strtoul(text, &p, 0);
        size = n;
        switch (*p) {
        case 't':
        case 'T':
                size *= 1024;
        case 'g':
        case 'G':
                size *= 1024;
        case 'm':
        case 'M':
                size *= 1024;
        case 'k':
        case 'K':
                size *= 1024;
                p++;
                if (*p && (*p == 'b' || *p == 'B'))
                        p++;
                break;

        case 0:
                break;
                
        default:
                parse_error(_("invalid size suffix (near %s)"), p);
                return 1;
        }

        if (size < n) {
                parse_error(_("invalid size: numeric overflow occurred"));
                return 2;
        }
        
        *psize = size;

        return 0;
}

static void
pragma_stacksize(int argc, char **argv, const char *text)
{
        size_t size, incr = stack_expand_incr, max_size = stack_max_size;
        enum stack_expand_policy policy = stack_expand_policy;

        switch (argc) {
        case 4:
                if (strtosize(argv[3], &max_size))
                        return;
        case 3:
                if (strcmp(argv[2], "twice") == 0) 
                        policy = stack_expand_twice;
                else {
                        policy = stack_expand_add;
                                
                        if (strtosize(argv[2], &incr))
                                return;
                }
        case 2:
                strtosize(argv[1], &size);
        }

        stack_size = size;
        stack_expand_incr = incr;
        stack_expand_policy = policy;
        stack_max_size = max_size;
}

void
pragma_setup()
{
	install_pragma("regex", 2, 0, pragma_regex);
	install_pragma("stacksize", 2, 4, pragma_stacksize);
}



/* Test run */
struct sfsistat_tab {
        char *name;
        sfsistat stat;
} sfsistat_tab[] = {
        { "accept", SMFIS_ACCEPT },
        { "continue", SMFIS_CONTINUE },
        { "discard", SMFIS_DISCARD },
        { "reject", SMFIS_REJECT },
        { "tempfail", SMFIS_TEMPFAIL },
        { NULL }
};

const char *
sfsistat_str(sfsistat stat)
{
        struct sfsistat_tab *p;
        for (p = sfsistat_tab; p->name; p++)
                if (p->stat == stat) 
                        return p->name;
        return NULL;
}

void
print_stat(sfsistat stat)
{
        struct sfsistat_tab *p;
        for (p = sfsistat_tab; p->name; p++)
                if (p->stat == stat) {
                        printf("%s", p->name);
                        return;
                }
        printf("%d", stat);
}

const char *
msgmod_opcode_str(enum msgmod_opcode opcode)
{
        switch (opcode) {
        case header_add:
                return "ADD HEADER";
                
        case header_replace:
                return "REPLACE HEADER";

        case header_delete:
                return "DELETE HEADER";

        case header_insert:
                return "INSERT HEADER";
                
        case rcpt_add:
                return "ADD RECIPIENT";

        case rcpt_delete:
                return "DELETE RECIPIENT";

        case quarantine:
                return "QUARANTINE";

        case body_repl:
                return "REPLACE BODY";

	case body_repl_fd:
		return "REPLACE BODY FROM FILE";
		
        case header_replace_nth:
                return "REPLACE NTH HEADER";

        case header_delete_nth:
                return "DELETE NTH HEADER";

        }
        return "UNKNOWN HEADER COMMAND";
}

static int
dbg_setreply(void *data, char *code, char *xcode, char *message)
{
        if (code) {
                printf("SET REPLY %s", code);
                if (xcode)
                        printf(" %s", xcode);
                if (message)
                        printf(" %s", message);
                printf("\n");
        }
        return 0;
}

static void
dbg_msgmod(void *data, struct msgmod_closure *clos)
{
	if (!clos)
		printf("clearing msgmod list\n");
	else
		printf("%s %s: %s %u\n", msgmod_opcode_str(clos->opcode),
		       SP(clos->name), SP(clos->value), clos->idx);
}

static const char *
dbg_dict_getsym (void *data, const char *str)
{
        return dict_getsym ((mu_assoc_t)data, str);
}

void
mailfromd_test(int argc, char **argv)
{
	int i, rc;
	mu_assoc_t dict = NULL;
	eval_environ_t env;
	char *p, *end;
	long n;
	sfsistat status;
	char *args[9] = {0,0,0,0,0,0,0,0,0};
		
	dict_init(&dict);
	env = create_environment(NULL,
				 dbg_dict_getsym, dbg_setreply, dbg_msgmod,
				 dict);
	env_init(env);
	xeval(env, smtp_state_begin);

	env_init(env);
	for (i = 0; i < argc; i++) {
		if (p = strchr(argv[i], '=')) {
			char *ident = argv[i];
			*p++ = 0;
			if (c_isdigit(*ident) && *ident != 0
				 && ident[1] == 0) 
				args[*ident - '0' - 1] = p;
			else 
				dict_install(dict, argv[i], p);
		}
	}

	for (i = state_parms[test_state].cnt; i--; ) {
		switch (state_parms[test_state].types[i]) {
		case dtype_string:
			env_push_string(env, args[i] ? args[i] : "");
			break;
		case dtype_number:
			if (args[i]) {
				n = strtol(args[i], &end, 0);
				if (*end) 
					mu_error(_("$%d is not a number"),
						 i+1);
			} else
				n = 0;
			env_push_number(env, n);
			break;
		default:
			abort();
		}
	}

	test_message_data_init(env);
	
	env_make_frame(env);

	rc = xeval(env, test_state);
	env_leave_frame(env, state_parms[test_state].cnt);
	env_final_gc(env);

	status = environment_get_status(env);

	env_init(env);
	xeval(env, smtp_state_end);

	printf("State %s: ", state_to_string(test_state));
	print_stat(status);
	printf("\n");
	destroy_environment(env);
}

void
mailfromd_run(prog_counter_t entry_point, int argc, char **argv)
{
	int rc, i;
	mu_assoc_t dict = NULL;
	eval_environ_t env;

	dict_init(&dict);
	env = create_environment(NULL,
				 dbg_dict_getsym, dbg_setreply, dbg_msgmod,
				 dict);

	env_init(env);
	test_message_data_init(env);
	
	env_push_number(env, 0);

	for (i = argc - 1; i >= 0; i--)
		env_push_string(env, argv[i]);
	env_push_number(env, argc);
	
	env_make_frame0(env);
	rc = eval_environment(env, entry_point);
	env_final_gc(env);
	rc = (int) env_get_reg(env);
	destroy_environment(env);
	exit(rc);
}

static struct tagtable {
        char *name;
        enum smtp_state tag;
} tagtable[] = {
        { "none", smtp_state_none },
        { "begin", smtp_state_begin },
        { "connect", smtp_state_connect },
        { "helo", smtp_state_helo },  
        { "envfrom", smtp_state_envfrom }, 
        { "envrcpt", smtp_state_envrcpt }, 
        { "data", smtp_state_data },
        { "header", smtp_state_header }, 
        { "eoh", smtp_state_eoh }, 
        { "body", smtp_state_body }, 
        { "eom", smtp_state_eom },
        { "end", smtp_state_end },
};

enum smtp_state
string_to_state(const char *name)
{
        struct tagtable *p;

        for (p = tagtable; p < tagtable + sizeof tagtable/sizeof tagtable[0];
             p++)
                if (strcasecmp (p->name, name) == 0)
                        return p->tag;

        return smtp_state_none;
}

const char *
state_to_string(enum smtp_state state)
{
        if (state < sizeof tagtable/sizeof tagtable[0])
                return tagtable[state].name;
        abort();
}

static NODE *
_reverse(NODE *list, NODE **root)
{
        NODE *next;

        if (list->next == NULL) {
                *root = list;
                return list;
        }
        next = _reverse(list->next, root);
        next->next = list;
        list->next = NULL;
        return list;
}               

NODE *
reverse(NODE *in)
{
        NODE *root;
        if (!in)
                return in;
        _reverse(in, &root);
        return root;
}

size_t
nodelistlength(NODE *p)
{
	size_t len = 0;
	for (; p; p = p->next)
		len++;
	return len;
}

static NODE *
create_asgn_node(struct variable *var, NODE *expr, const struct locus *loc)
{
        NODE *node;
        data_type_t t = node_type(expr);

        if (t == dtype_unspecified) {
                parse_error(_("unspecified value not ignored as it should be"));
                return NULL;
        }
        node = alloc_node(node_type_asgn, loc);
        node->v.asgn.var = var;
        node->v.asgn.nframes = catch_nesting;
        node->v.asgn.node = cast_to(var->type, expr);
        return node;
}


NODE *
function_call(struct function *function, size_t count, NODE *subtree)
{
        NODE *np = NULL;
        if (count < function->parmcount - function->optcount) {
                parse_error(_("too few arguments in call to `%s'"),
                            function->sym.name);
        } else if (count > function->parmcount && !function->varargs) {
                parse_error(_("too many arguments in call to `%s'"),
                            function->sym.name);
        } else {
                np = alloc_node(node_type_call, get_locus());
                np->v.call.func = function;
                np->v.call.args = reverse(cast_arg_list(subtree,
                                                        function->parmcount,
                                                        function->parmtype,
                                                        0));
        }
        return np;
}       

data_type_t
node_type(NODE *node)
{
	switch (node->type) {
	case node_type_string:
	case node_type_symbol:
		return dtype_string;

	case node_type_number:
		return dtype_number;
		
	case node_type_if:
		return dtype_unspecified;
		
	case node_type_bin:
		return dtype_number;
		
	case node_type_un:
		return dtype_number;
		
	case node_type_builtin:
		return node->v.builtin.builtin->rettype;
		
	case node_type_concat:
		return dtype_string;
		
	case node_type_variable:
		return node->v.var_ref.variable->type;
		
	case node_type_arg:
		return node->v.arg.data_type;

	case node_type_argx:
		return dtype_string;
		
	case node_type_call:
		return node->v.call.func->rettype;
		
	case node_type_return:
		if (node->v.node)
			return node_type(node->v.node);
		break;

	case node_type_backref:
		return dtype_string;

	case node_type_cast:
		return node->v.cast.data_type;

	case node_type_offset:
		return dtype_number;

	case node_type_vaptr:
		return dtype_number;
		
	case node_type_result:
	case node_type_header:
	case node_type_asgn:
	case node_type_regex:
	case node_type_regcomp:
	case node_type_catch:
	case node_type_try:
	case node_type_throw:
	case node_type_echo:
	case node_type_switch:
	case node_type_funcdecl:
	case node_type_progdecl:
	case node_type_noop:
	case node_type_next:
	case node_type_break:
	case node_type_loop:
	case max_node_type:
		break;
	}
	return dtype_unspecified;
}

NODE *
cast_to(data_type_t type, NODE *node)
{
        NODE *np;
        data_type_t ntype = node_type(node);
        
        switch (ntype) {
        case dtype_string:
        case dtype_number:
                if (type == ntype)
                        return node;
                break;
                
        case dtype_pointer:
                if (type == ntype)
                        return node;
                break;
                
        case dtype_unspecified:
                parse_error(_("cannot convert %s to %s"), type_to_string(ntype),
                            type_to_string(type));
                return NULL;

        default:
                abort();
        }
        np = alloc_node(node_type_cast, get_locus());
        np->v.cast.data_type = type;
        np->v.cast.node = node;
        node->next = NULL;
        return np;
}

NODE *
cast_arg_list(NODE *args, size_t parmc, data_type_t *parmtype, int disable_prom)
{
        NODE *head = NULL, *tail = NULL;
        
        while (args) {
                NODE *next = args->next;
                NODE *p;
                data_type_t type;
                
                if (parmc) {
                        type = *parmtype++;
                        parmc--;
                } else if (disable_prom)
                        type = node_type(args);
                else
                        type = dtype_string;
                
                p = cast_to(type, args);

                if (head)
                        tail->next = p;
                else
                        head = p;
                tail = p;
                args = next;
        }
        return head;
}

void
add_xref(struct variable *var, const struct locus *locus)
{
        if (script_dump_xref) {
                struct locus *elt = xmalloc(sizeof *elt);
                if (!var->xref)
                        mu_list_create(&var->xref);
                *elt = *locus;
                mu_list_append(var->xref, elt);
        }
}

struct variable *
vardecl(const char *name, data_type_t type, storage_class_t sc,
        struct locus *loc)
{
        struct variable *var;
        const struct constant *cptr;

        if (type == dtype_unspecified) {
                parse_error(_("cannot define variable of unspecified type"));
                return NULL;
        }
        var = variable_install(name);
        if (var->type == dtype_unspecified) {
                /* the variable has just been added: go straight to
                   initializing it */;
        } else if (sc != var->storage_class) {
                struct variable *vp;
                
                switch (sc) {
                case storage_extern:
                        parse_error(_("INTERNAL ERROR at %s:%d, declaring %s %s"),
                                    __FILE__, __LINE__,
                                    storage_class_str(sc), name);
                        abort();

                case storage_auto:
                        if (var->storage_class == storage_param) {
                                parse_warning(_("automatic variable `%s' "
                                                "is shadowing a parameter"),
                                              var->sym.name);
                        } else
                                parse_warning(_("automatic variable `%s' "
                                                "is shadowing a global"), 
                                              var->sym.name);
                        unregister_auto(var);
                        break;

                case storage_param:
                        parse_warning(_("parameter `%s' is shadowing a "
                                        "global"),
                                      name);
                }

                /* Do the shadowing */
                vp = variable_replace(var->sym.name, NULL);
                vp->shadowed = var;
                var = vp;
        } else {
                switch (sc) {
                case storage_extern:
                        if (var->type != type) {
                                parse_error(_("redeclaring `%s' as different "
                                              "data type"),
                                            name);
                                parse_error_locus(&var->sym.locus,
                                            _("this is the location of the "
                                              "previous definition"));
                                return NULL;
                        }
                        break;

                case storage_auto:
                        if (var->type != type) {
                                parse_error(_("redeclaring `%s' as different "
                                              "data type"),
                                            name);
                                parse_error_locus(&var->sym.locus,
                                            _("this is the location of the "
                                              "previous definition"));
                                return NULL;
                        } else {
                                parse_error(_("duplicate variable: %s"), name);
                                return NULL;
                        }
                        break;

                case storage_param:
                        parse_error(_("duplicate parameter: %s"), name);
                        return NULL;
                }
        }

        /* FIXME: This is necessary because constants can be
           referred to the same way as variables. */
        if (cptr = constant_lookup(name)) {
                parse_warning(_("variable name `%s' clashes with a constant name"),
                              name);
                parse_warning_locus(&cptr->sym.locus,
                                    _("this is the location of the "
                                      "previous definition"));
        }
        
        var->type = type;
        var->storage_class = sc;
        switch (sc) {
        case storage_extern:
                add_xref(var, loc ? loc : get_locus());
                break;
        case storage_auto:
        case storage_param:
                register_auto(var);
        }
        var->sym.locus = *get_locus();
        return var;
}

static int
cast_value(data_type_t type, struct value *value)
{
        if (type != value->type) {
                char buf[NUMERIC_BUFSIZE_BOUND];
                char *p;
                
                switch (type) {
                default:
                        abort();
                        
                case dtype_string:
                        snprintf(buf, sizeof buf, "%ld", value->v.number);
                        value->v.literal = string_alloc(buf, strlen(buf));
                        break;

                case dtype_number:
                        value->v.number = strtol(value->v.literal->text,
                                                 &p, 10);
                        if (*p) {
                                parse_error(_("cannot convert `%s' to number"),
                                            value->v.literal->text);
                                return 1;
                        }
                        break;
                }
                value->type = type;
        }
        return 0;
}

static struct variable *
externdecl(const char *name, struct value *value, struct locus *loc)
{
        struct variable *var = vardecl(name, value->type, storage_extern, loc);
        if (!var)
                return NULL;
        if (initialize_variable(var, value, loc))
                return NULL;
        return var;
}


struct deferred_decl {
        struct deferred_decl *next;
        struct literal *name;
        struct value value;
	struct locus locus;
};

struct deferred_decl *deferred_decl;

void
defer_initialize_variable(const char *arg, const char *val,
			  struct locus *ploc)
{
        struct deferred_decl *p;
        struct literal *name = string_alloc(arg, strlen(arg));
        for (p = deferred_decl; p; p = p->next)
                if (p->name == name) {
                        parse_warning_locus(NULL, _("redefining variable %s"),
                                            name->text);
                        p->value.type = dtype_string;
                        p->value.v.literal = string_alloc(val, strlen(val));
			p->locus = *ploc;
                        return;
                }
        p = xmalloc(sizeof *p);
        p->name = name;
        p->value.type = dtype_string;
        p->value.v.literal = string_alloc(val, strlen(val));
	p->locus = *ploc;
        p->next = deferred_decl;
        deferred_decl = p;
}

static void
apply_deferred_init()
{
        struct deferred_decl *p;
        for (p = deferred_decl; p; p = p->next) {
                struct variable *var = variable_lookup(p->name->text);
                if (!var) {
			mu_error(_("<command line>: warning: "
				   "no such variable: %s"),
				 p->name->text);
                        continue;
                }
                if (initialize_variable(var, &p->value, &p->locus))
                        parse_error_locus(&p->locus,
					  _("error initialising variable %s: incompatible types"),
					  p->name->text);
        }
}


struct declvar {
        struct declvar *next;
        struct locus locus;
        struct variable *var;
        struct value val;
};

static struct declvar *declvar;

void
set_poll_arg(struct poll_data *poll, int kw, NODE *expr)
{
        switch (kw) {
        case T_FOR:
                poll->email = expr;
                break;
                
        case T_HOST:
                poll->client_addr = expr;
                break;
                
        case T_AS:
                poll->mailfrom = expr;
                break;
                
        case T_FROM:
                poll->ehlo = expr;
                break;
                
        default:
                abort();
        }
}
                
int
initialize_variable(struct variable *var, struct value *val,
                    const struct locus *locus)
{
        struct declvar *dv;

        if (cast_value(var->type, val))
                return 1;
        for (dv = declvar; dv; dv = dv->next)
                if (dv->var == var) {
                        if (dv->locus.file) {
                                parse_warning_locus(locus,
                                     _("variable `%s' already initialized"),
                                                    var->sym.name);
                                parse_warning_locus(&dv->locus,
                                     _("this is the location of the "
                                       "previous initialization"));
                        }
                        if (locus)
                                dv->locus = *locus;
                        else {
                                dv->locus.file = NULL;
                                dv->locus.line = 0;
                        }
                        dv->val = *val;
                        return 0;
                }

        dv = xmalloc(sizeof *dv);
        dv->next = declvar;
        dv->var = var;
	if (locus)
		dv->locus = *locus;
	else {
		dv->locus.file = "<unknown>";
		dv->locus.line = 1;
	}
        dv->val = *val;
        declvar = dv;
	var->sym.flags |= SYM_INITIALIZED;
        return 0;
}


void
ensure_initialized_variable(const char *name, struct value *val)
{
        struct declvar *dv;     
        struct variable *var = variable_lookup(name);

        if (!var) {
                mu_error(_("INTERNAL ERROR at %s:%d: variable to be "
                           "initialized is not declared"),
                         __FILE__, __LINE__);
                abort();
        }
        if (var->type != val->type)
                mu_error(_("INTERNAL ERROR at %s:%d: variable to be "
                           "initialized has wrong type"),
                         __FILE__, __LINE__);
        for (dv = declvar; dv; dv = dv->next)
                if (dv->var == var)
                        return;
        dv = xmalloc(sizeof *dv);
        dv->locus.file = NULL;
        dv->locus.line = 0;
        dv->var = var;
        dv->val = *val;
        dv->next = declvar;
        declvar = dv;
}

static int
_ds_variable_count_fun(void *sym, void *data)
{
        struct variable *var = sym;

        if ((var->sym.flags & (SYM_VOLATILE | SYM_REFERENCED))
	    && !(var->sym.flags & SYM_PASSTOGGLE)) {
		var->sym.flags |= SYM_PASSTOGGLE;
                variable_count++;
                if (var->type == dtype_string) 
                        dataseg_reloc_count++;
                if (var->sym.flags & SYM_PRECIOUS)
                        precious_count++;
        }
        return 0;
}

static int
_ds_variable_fill_fun(void *sym, void *data)
{
        struct variable *var = sym;
        
        if (var->sym.flags & SYM_PASSTOGGLE) {
		var->sym.flags &= ~SYM_PASSTOGGLE;
                struct variable ***vtabptr = data;
                **vtabptr = var;
                ++*vtabptr;
        }
        return 0;
}

static int
_ds_reloc_fun(void *sym, void *data)
{
        struct variable *var = sym;
        size_t *pi = data;
        
        if ((var->sym.flags & (SYM_VOLATILE | SYM_REFERENCED))
	    && !(var->sym.flags & SYM_PASSTOGGLE)
	    && var->type == dtype_string) {
		var->sym.flags |= SYM_PASSTOGGLE;
                dataseg_reloc[(*pi)++] = var->off;
	}
        return 0;
}

static int
_ds_literal_count_fun(void *sym, void *data)
{
        struct literal *lit = sym;
        size_t *offset = data;
        if (!(lit->flags & SYM_VOLATILE) && (lit->flags & SYM_REFERENCED)) {
                lit->off = *offset;
                *offset += B2STACK(strlen(lit->text) + 1);
        }
        return 0;
}

static int
_ds_literal_copy_fun(void *sym, void *data)
{
        struct literal *lit = sym;
        if (!(lit->flags & SYM_VOLATILE) && (lit->flags & SYM_REFERENCED)) 
                strcpy((char*)(dataseg + lit->off), lit->text);
        return 0;
}

static int
vtab_comp(const void *a, const void *b)
{
        const struct variable *vp1 = *(const struct variable **)a;
        const struct variable *vp2 = *(const struct variable **)b;

        if ((vp1->sym.flags & SYM_PRECIOUS)
            && !(vp2->sym.flags & SYM_PRECIOUS))
                return 1;
        else if ((vp2->sym.flags & SYM_PRECIOUS) 
                 && !(vp1->sym.flags & SYM_PRECIOUS))
                return -1;
        return 0;
}

static int
place_exc(const struct constant *cp, const struct literal *lit, void *data)
{
	STKVAL *tab = data;
	tab[cp->value.v.number] = (STKVAL) lit->off;
	return 0;
}

static void
dataseg_layout()
{
	struct declvar *dv;
	size_t i;
	struct switch_stmt *sw;
	struct variable **vtab, **pvtab;
	struct exmask *exmask;
	
	/* Count used variables and estimate the number of relocations
	   needed */
	dataseg_reloc_count = 0;
	module_symtab_enumerate(namespace_variable,
				_ds_variable_count_fun,
				NULL);

	/* Fill variable pointer array and make sure precious variables
	   occupy its bottom part */
	vtab = xcalloc(variable_count, sizeof(vtab[0]));
	pvtab = vtab;
	module_symtab_enumerate(namespace_variable,
				_ds_variable_fill_fun,
				&pvtab);
	qsort(vtab, variable_count, sizeof(vtab[0]), vtab_comp);

	/* Compute variable offsets. Offset 0 is reserved for NULL symbol */
	for (i = 0; i < variable_count; i++) {
		vtab[i]->off = i + 1;
		if (vtab[i]->addrptr)
			*vtab[i]->addrptr = vtab[i]->off;
	}

	/* Free the array */
	free(vtab);
	
	/* Mark literals used to initialize variables as referenced */
	for (dv = declvar; dv; dv = dv->next) {
		if ((dv->var->sym.flags & (SYM_VOLATILE | SYM_REFERENCED))
		    && dv->var->type == dtype_string) {
			dv->val.v.literal->flags |= SYM_REFERENCED;
		}
	}

	datasize = variable_count + 1;
	dvarsize = datasize - precious_count;
	
	/* Count referenced literals and adjust the data size */
	symtab_enumerate(stab_literal, _ds_literal_count_fun, &datasize);

	/* Account for switch translation tables */
	for (sw = switch_root; sw; sw = sw->next) {
		sw->off = datasize;
		datasize += sw->tabsize;
	}

	/* Account for exception masks */
	for (exmask = exmask_root; exmask; exmask = exmask->next) {
		exmask->off = datasize;
		if (exmask->all) {
			size_t i;
			for (i = 0; i < exception_count; i++)
				bitmask_set(&exmask->bm, i);
		}
		datasize += exmask->bm.bm_size + 1;
	}

	/* Account for exception name table */
	datasize += exception_count;
	
	/* Allocate data segment and relocation table */
	dataseg = xcalloc(datasize, sizeof(STKVAL));
	dataseg_reloc = xcalloc(dataseg_reloc_count, sizeof *dataseg_reloc);

	/* Fill relocation table */
	i = 0;
	module_symtab_enumerate(namespace_variable, _ds_reloc_fun, &i);
	
	/* Initialize variables */
	for (dv = declvar; dv; dv = dv->next) {
		if (dv->var->sym.flags & (SYM_VOLATILE | SYM_REFERENCED)) {
			switch (dv->var->type) {
			case dtype_string:
				dataseg[dv->var->off] =
					(STKVAL) dv->val.v.literal->off;
				break;

			case dtype_number:
				dataseg[dv->var->off] =
					(STKVAL) dv->val.v.number;
				break;

			default:
				abort();
			}
		}
	}	

	/* Place literals */
	symtab_enumerate(stab_literal, _ds_literal_copy_fun, NULL);

	/* Initialize exception masks */
	for (exmask = exmask_root; exmask; exmask = exmask->next) {
		size_t i, off = exmask->off;
		
		dataseg[off++] = (STKVAL) exmask->bm.bm_size;
		for (i = 0; i < exmask->bm.bm_size; i++)
			dataseg[off++] = (STKVAL) exmask->bm.bm_bits[i++];
	}

	/* Initialize exception name table */
	enumerate_exceptions(place_exc, dataseg + EXTABIND);
}


static int
_regex_compile_fun(void *sym, void *data)
{
        struct literal *lit = sym;
        if (lit->regex) {
                struct sym_regex *rp;
                for (rp = lit->regex; rp; rp = rp->next) 
                        register_regex(rp);
        }
        return 0;
}

void
regex_layout()
{
        symtab_enumerate(stab_literal, _regex_compile_fun, NULL);
        finalize_regex();
}


static struct variable *auto_list;

static void
register_auto(struct variable *var)
{
        var->next = auto_list;
        auto_list = var;
}

static void
unregister_auto(struct variable *var)
{
        struct variable *p = auto_list, *prev = NULL;
        while (p) {
                struct variable *next = p->next;
                if (p == var) {
                        if (prev)
                                prev->next = next;
                        else
                                auto_list = next;
                        p->next = NULL;
                        return;
                }
                prev = p;
                p = next;
        }
}

/* FIXME: Redo shadowing via a separate table? */
static size_t
forget_autos(size_t nparam, size_t auto_count, size_t hidden_arg)
{
        size_t param_count = 0;
        struct variable *var = auto_list;
        while (var) {
                struct variable *next = var->next;
                switch (var->storage_class) {
                case storage_auto:
                        var->off = auto_count++;
                        break;
                case storage_param:
                        var->off = nparam - param_count++;
                        var->ord = var->off - (hidden_arg ? 1 : 0) - 1;
                        break;
                default:
                        abort();
                }
                while (var->storage_class != storage_extern) {
                        struct variable *shadowed = var->shadowed;
                        if (!shadowed) {
                                symtab_remove(TOP_MODULE_SYMTAB(namespace_variable),
                                              var->sym.name);
                                break;
                        }
                        var->shadowed = NULL;
                        var = variable_replace(var->sym.name, shadowed);
                }
                var = next;
        }
        auto_list = NULL;
        return auto_count;
}

const char *
storage_class_str(storage_class_t sc)
{
        switch (sc) {
        case storage_extern:
                return "extern";
        case storage_auto:
                return "auto";
        case storage_param:
                return "param";
        }
        return "unknown?";
}


const char *
function_name()
{
        switch (outer_context) {
        case context_function:
                return func->sym.name;
        case context_handler:
                return state_to_string(state_tag);
        default:
                return "";
        }
}

NODE *
declare_function(struct function *func, struct locus *loc, size_t nautos)
{
        NODE *node = alloc_node(node_type_funcdecl, loc);
        node->v.funcdecl.func = func;
        node->v.funcdecl.auto_count = nautos;
        node->v.funcdecl.tree = func->node; 
        return node;
}


NODE *
create_node_variable(struct variable *var, const struct locus *locus)
{
        NODE *node = alloc_node(node_type_variable, locus);
        node->v.var_ref.variable = var;
        node->v.var_ref.nframes = catch_nesting;
        return node;
}

NODE *
create_node_argcount(const struct locus *locus)
{
        NODE *node;
        
        if (outer_context == context_function) {
                if (func->optcount || func->varargs) {
                        node = alloc_node(node_type_arg, locus);
                        node->v.arg.data_type = dtype_number;
                        node->v.arg.number = 1;
                } else {
                        node = alloc_node(node_type_number, locus);
                        node->v.number = parminfo[outer_context].parmcount();
                }
        } else {
                node = alloc_node(node_type_number, locus);
                node->v.number = parminfo[outer_context].parmcount();
        }
        return node;
}

NODE *
create_node_arg(long num, const struct locus *locus)
{
        NODE *node;
        
        if (inner_context == context_function && func->varargs)
                ;
        else if (num > PARMCOUNT()) 
                parse_error(_("argument number too high"));
        node = alloc_node(node_type_arg, locus);
        node->v.arg.data_type = PARMTYPE(num);
        node->v.arg.number = num;
        if (inner_context == context_function)
                node->v.arg.number += FUNC_HIDDEN_ARGS(func);
        return node;
}

NODE *
create_node_symbol(struct literal *lit, const struct locus *locus)
{
        NODE *node;
        register_macro(state_tag, lit->text);
        node = alloc_node(node_type_symbol, locus);
        node->v.literal = lit;
        return node;
}

NODE *
create_node_backref(long num, const struct locus *locus)
{
        NODE *node = alloc_node(node_type_backref, locus);
        node->v.number = num;
        return node;
}
